/************************************************************************
 *
 * AJButton.java -
 *
 * $Id: AJButton.java,v 1.1.1.1 2006/06/30 23:38:03 priimak Exp $
 *
 *-----------------------------------------------------------------------
 * Copyright (c) 2002, Board of Trustees, Leland Stanford Jr. University
 ************************************************************************/
import java.lang.*;
import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class AJButton extends BButton {

    public static final boolean MOUSABLE     = true;
    public static final boolean NOT_MOUSABLE = false;

    public Hashtable box;
    public Object obj;

    public AJButton(String label, Hashtable box) {
        this(label, box, true);
    }
    public AJButton(String label, Hashtable box, boolean mouseable) {
        super(label);
        this.box = box;
        this.addKeyListener(new KeyAdapter() {
                public void keyPressed(KeyEvent e) {
                    if( e.getKeyCode() == KeyEvent.VK_ENTER )
                        ((AJButton)e.getComponent()).doClick();
                }
            });
        if( mouseable )
            this.addMouseListener(new MouseAdapter() {
                    public void mousePressed(MouseEvent e) {
                        ((AJButton)e.getComponent()).doClick();
                    }
                });
    }

    public AJButton(String label) {
        this(label, new Hashtable());
    }

    public Object put(String key, Object value) {
        return box.put(key, value);
    }

    public Object get(String key) {
        return box.get(key);
    }

    public String getStr(String key) {
        return (String)box.get(key);
    }

    public Hashtable getHash(String key) {
        return (Hashtable)box.get(key);
    }
}
