/************************************************************************
 *
 * AJCheckBox.java - we need this class in order to be able to store
 *                   complex data structures in JCheckBox which does not
 *                   provide it.
 *
 * $Id: AJCheckBox.java,v 1.1.1.1 2006/06/30 23:38:03 priimak Exp $
 *
 *-----------------------------------------------------------------------
 * Copyright (c) 2002, Board of Trustees, Leland Stanford Jr. University
 ************************************************************************/
import java.lang.*;
import java.util.*;
import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;

public class AJCheckBox extends JPanel {

    public Object object;
    public Object obj2;
    public Object obj3;
    public Object obj4;
    public Hashtable box;

    private JCheckBox cb;
    private JLabel label;

    private AJCheckBox THIS;

    public AJCheckBox(Object obj, boolean selected) {
        this(obj, selected, null);
    }

    public AJCheckBox(Object obj, boolean selected, Hashtable box) {
        super(new FlowLayout(FlowLayout.LEFT));
        THIS = this;
        cb = new JCheckBox("", selected) {
                public AJCheckBox getAJCheckBox() {
                    return THIS;
                }
            };
        this.add(cb);
        label = new JLabel(obj.toString());
        this.add(label);
        this.setBackground(Color.white);
        this.object = obj;
        this.box = box;
    }

    public void setMargin(Insets ins) {
        cb.setMargin(ins);
    }

    public void addChangeListener(ChangeListener cl) {
        cb.addChangeListener(cl);
    }

    public void setBackground(Color color) {
        super.setBackground(color);
        if( cb != null )
            cb.setBackground(color);
    }

    public void setFont(Font font) {
        super.setFont(font);
        if( cb != null )
            cb.setFont(font);
        if( label != null )
            label.setFont(font);
    }

    public void addActionListener(java.awt.event.ActionListener l) {
        cb.addActionListener(l);
    }

    public Object put(String key, Object value) {
        return box.put(key, value);
    }

    public Object get(String key) {
        return box.get(key);
    }

    public String getStr(String key) {
        return (String)box.get(key);
    }

    public Hashtable getHash(String key) {
        return (Hashtable)box.get(key);
    }

    public boolean isSelected() {
        return cb.isSelected();
    }

    public void setSelected(boolean b) {
        cb.setSelected(b);
    }

    public void setEnabled(boolean b) {
        cb.setEnabled(b);
    }

    public String getText() {
        return label.getText();
    }

}
