/************************************************************************
 *
 * NetworkDHCPNameFocusListener.java -
 *
 * $Id: NetworkDHCPNameFocusListener.java,v 1.2 2006/09/26 16:55:54 priimak Exp $
 *
 *-----------------------------------------------------------------------
 * Copyright (c) 2002, Board of Trustees, Leland Stanford Jr. University
 ************************************************************************/
import java.awt.*;
import java.awt.event.*;
import java.lang.*;
import java.util.*;
import stanford.netdb.utils.*;

public class NetworkDHCPNameFocusListener implements FocusListener {

    public void focusGained(FocusEvent e) {
    }

    public void focusLost(FocusEvent e) {
        doAction((AJTextField)e.getSource());
    }

    public void doAction(AJTextField tf) {
        Utils.debug((String)tf.box.get("id"));
        NetworkModifyFrame parent = (NetworkModifyFrame)tf.box.get("window");
        Hashtable as = (Hashtable)parent.addrSpacesH.get((String)tf.box.get("id"));
        Hashtable dhcpIP = (Hashtable)((Hashtable)as.get("dhcp_addresses")).get(tf.key);
        Hashtable names = (Hashtable)dhcpIP.get("names");
        if( names == null ) {
            names = new Hashtable();
            dhcpIP.put("names", names);
        }
        Enumeration enm = names.keys();
        Hashtable name;
        String key;
        if( enm.hasMoreElements() ) {
            key = (String)enm.nextElement();
            name = (Hashtable)names.get(key);
        } else {
            name = new Hashtable();
            key = "name "+(parent.available_key++);
            names.put(key, name);
            name.put("name", "");
            name.put("domain", "");
        }
        String oldName = ((String)name.get("name")).trim()+"."+((String)name.get("domain")).trim();
        String newName = tf.getText().trim();
        String nameStr;
        String domainStr;
        if( !oldName.equals(newName) ) {
            int dotIndex = newName.indexOf(".");
            if( dotIndex < 0 ) {
                nameStr = newName;
                domainStr = (String)parent.oldNet.get("default_domain");
                if( newName.length() == 0 ) {
                    names.remove(key);
                    return;
                }
            } else {
                nameStr = newName.substring(0, dotIndex);
                domainStr = newName.substring(dotIndex+1);
            }

            name.put("name", nameStr);
            name.put("domain", domainStr);
            dhcpIP.put("dirty_name", "");
        }
    }
}
