/************************************************************************
 *
 * OSFrame.java -
 *
 * $Id: OSFrame.java,v 1.1.1.1 2006/06/30 23:38:03 priimak Exp $
 *
 *-----------------------------------------------------------------------
 * Copyright (c) 2001 Board of Trustees, Leland Stanford Jr. University
 ************************************************************************/
import java.lang.*;
import java.util.*;
import java.io.*;
import java.sql.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.tree.*;
import javax.swing.table.*;
import stanford.netdb.utils.*;

public class OSFrame extends XFrame implements Runnable {

    public Hashtable osList = null;
    public JList osList1;
    public JList osList2;
    public JButton becomesB = new JButton("Replace");
    public JButton addB = new JButton("Add");
    public JButton modB = new JButton("Mod");
    public JButton delB = new JButton("Del");
    public JPanel osPanel;
    public JPanel msgPanel;
    public JLabel msgLabel = new JLabel("", SwingConstants.CENTER);
    public Exception myException = null;

    public static JDialog modifyDialogWin = null;
    public Object[] buttons;
    public JTextField osNameF;
    public JTextField osCommentF;
    public String osName;
    public String osComment;

    public static OSFrame THIS = null;

    public OSFrame() {
        super("OS Management");
        if( THIS != null ) {
            THIS.setState(Frame.NORMAL);
            THIS.toFront();
            return;
        }
        label.setText("Loading OS list...");
        min_label_length = 0;

        THIS = this;

        initFrame();
        register();
    }

    public void dispose() {
        THIS = null;
        super.dispose();
    }

    private void initFrame() {
        init(); // init XTestFrame bowls

        msgPanel = new JPanel(new BorderLayout());
        msgPanel.setBackground(Color.white);
        msgPanel.add(msgLabel, BorderLayout.CENTER);

        becomesB.addActionListener(new AActionListener(this) {
                public void actionPerformed(ActionEvent event) {
                    Object[] list1 = osList1.getSelectedValues();
                    if( list1 == null )
                        list1 = new Object[0];

                    String toOS = (String)osList2.getSelectedValue();
                    if( toOS != null ) {
                        String toComment = (String)osList.get(toOS);
                        if( toComment == null )
                            toComment = "";
                        Hashtable newOS = new Hashtable();
                        newOS.put("object", "os");
                        newOS.put("name", toOS.trim());
                        newOS.put("comment", toComment.trim());

                        central_panel.removeAll();
                        central_panel.add(msgPanel);
                        msgLabel.setText("Replacing OS(es)...");
                        msgPanel.revalidate();
                        central_panel.revalidate();
                        central_panel.repaint();

                        (new OSThread((OSFrame)parent, list1, newOS)).start();
                    }
                }
            });

        addB.addActionListener(new AActionListener(this) {
                public void actionPerformed(ActionEvent event) {
                    try {
                        OSFrame frame = (OSFrame)parent;

                        JPanel panel = new JPanel(new GridLayout(6, 1));
                        panel.add(new JLabel("<html><body>OS Name: <font color=\"#EE0000\">*</font></body></html>"));
                        panel.add(osNameF = new JTextField("", 40));
                        osNameF.addKeyListener(new KeyAdapter() {
                                public void keyPressed(KeyEvent e) {
                                    if( e.getKeyCode() == KeyEvent.VK_ENTER )
                                        ((JTextField)e.getSource()).transferFocus();
                                }
                            });
                        panel.add(new JLabel(" "));
                        panel.add(new JLabel("Comment:"));
                        panel.add(osCommentF = new JTextField(""));
                        osCommentF.addKeyListener(new KeyAdapter() {
                                public void keyPressed(KeyEvent e) {
                                    if( e.getKeyCode() == KeyEvent.VK_ENTER )
                                        ((JButton)THIS.buttons[0]).doClick();
                                }
                            });
                        panel.add(new JLabel(" "));

                        frame.buttons = new Object[2];
                        frame.buttons[0] = new JButton("Save");
                        ((JButton)(frame.buttons[0])).addActionListener(new AActionListener(frame) {
                                public void actionPerformed(ActionEvent ev) {
                                    String osName = ((OSFrame)parent).osNameF.getText().trim();
                                    if( osName.length() == 0 )
                                        return;
                                    if( osName.length() > 255 )
                                        osName = osName.substring(0, 254);
                                    ((OSFrame)parent).modifyDialogWin.hide();
                                    Hashtable newOS = new Hashtable();
                                    newOS.put("object", "os");
                                    newOS.put("name", osName);
                                    String osComment = ((OSFrame)parent).osCommentF.getText().trim();
                                    if( osComment.length() > 60 )
                                        osComment = osComment.substring(0, 60);
                                    newOS.put("comment", osComment);

                                    central_panel.removeAll();
                                    central_panel.add(msgPanel);
                                    msgLabel.setText("Adding OS...");
                                    msgPanel.revalidate();
                                    central_panel.revalidate();
                                    central_panel.repaint();

                                    (new OSThread((OSFrame)parent, newOS, "OS has been added")).start();
                                }
                            });

                        frame.buttons[1] = new JButton("Cancel");
                        ((JButton)(frame.buttons[1])).addActionListener(new AActionListener(frame) {
                                public void actionPerformed(ActionEvent ev) {
                                    ((OSFrame)parent).modifyDialogWin.dispose();
                                }
                            });

                        JOptionPane modDialog =
                            new JOptionPane(panel, JOptionPane.PLAIN_MESSAGE, JOptionPane.OK_CANCEL_OPTION, null, frame.buttons);
                        modifyDialogWin = modDialog.createDialog(parent, "Add OS");
                        modifyDialogWin.show();

                    } catch(Exception exx) {
                        JOptionPane.showMessageDialog(parent,
                                exx.getMessage(), "Error", JOptionPane.ERROR_MESSAGE);
                        return;
                    }
                }
            });

        delB.addActionListener(new AActionListener(this) {
                public void actionPerformed(ActionEvent event) {
                    try {
                        Object[] list1 = osList1.getSelectedValues();
                        if( list1 == null || list1.length == 0 )
                            return;

                        String msg = "<html><body>Delete OS"+(list1.length>1?"es?:<br><br>":"");
                        for( int i = 0; i < list1.length; i++ )
                            msg += "&nbsp;"+(list1.length==1?"<i>":"")+Utils.htmlize(list1[i].toString().trim())+
                                (i+1<list1.length?"<br>":"")+(list1.length==1?"</i>":"");
                        if( list1.length == 1 )
                            msg += " ?";

                        if( JOptionPane.showConfirmDialog(parent, msg+"</body></html>",
                                                          "Delete OS"+(list1.length>1?"es?":"")+" ?",
                                                          JOptionPane.YES_NO_OPTION) != 0 )
                            return;

                        central_panel.removeAll();
                        central_panel.add(msgPanel);
                        msgLabel.setText("");
                        msgPanel.revalidate();
                        central_panel.revalidate();
                        central_panel.repaint();

                        (new OSThread((OSFrame)parent, list1)).start();

                    } catch(Exception exx) {
                        JOptionPane.showMessageDialog(parent,
                                                      exx.getMessage(), "Error", JOptionPane.ERROR_MESSAGE);
                        return;
                    }
                }
            });

        modB.addActionListener(new AActionListener(this) {
                public void actionPerformed(ActionEvent event) {
                    try {
                        OSFrame frame = (OSFrame)parent;
                        Object[] list1 = osList1.getSelectedValues();
                        if( list1 == null || list1.length == 0 )
                            return;

                        if( list1.length > 1 )
                            throw new Exception("You should select only one OS for modification");

                        JPanel panel = new JPanel(new GridLayout(6, 1));
                        panel.add(new JLabel("<html><body>OS Name: <font color=\"#EE0000\">*</font></body></html>"));
                        panel.add(osNameF = new JTextField(osName = list1[0].toString().trim(), 40));
                        osNameF.addKeyListener(new KeyAdapter() {
                                public void keyPressed(KeyEvent e) {
                                    if( e.getKeyCode() == KeyEvent.VK_ENTER )
                                        ((JTextField)e.getSource()).transferFocus();
                                }
                            });
                        panel.add(new JLabel(" "));
                        panel.add(new JLabel("Comment:"));
                        panel.add(osCommentF = new JTextField(osComment = ((String)osList.get((String)list1[0])).trim()));
                        osCommentF.addKeyListener(new KeyAdapter() {
                                public void keyPressed(KeyEvent e) {
                                    if( e.getKeyCode() == KeyEvent.VK_ENTER )
                                        ((JButton)THIS.buttons[0]).doClick();
                                }
                            });
                        panel.add(new JLabel(" "));

                        frame.buttons = new Object[3];
                        frame.buttons[0] = new JButton("Save");
                        ((JButton)(frame.buttons[0])).addActionListener(new AActionListener(frame) {
                                public void actionPerformed(ActionEvent ev) {
                                    String osNameNew = ((OSFrame)parent).osNameF.getText().trim();
                                    if( osNameNew.length() == 0 )
                                        return;
                                    if( osNameNew.length() > 255 )
                                        osNameNew = osNameNew.substring(0, 254);
                                    ((OSFrame)parent).modifyDialogWin.hide();
                                    Object[] oldOSName = new Object[1];
                                    oldOSName[0] = osName;
                                    Hashtable newOS = new Hashtable();
                                    newOS.put("object", "os");
                                    newOS.put("name", osNameNew);
                                    String osComment = ((OSFrame)parent).osCommentF.getText().trim();
                                    if( osComment.length() > 60 )
                                        osComment = osComment.substring(0, 60);
                                    newOS.put("comment", osComment);

                                    central_panel.removeAll();
                                    central_panel.add(msgPanel);
                                    msgLabel.setText("Modifying OS...");
                                    msgPanel.revalidate();
                                    central_panel.revalidate();
                                    central_panel.repaint();

                                    (new OSThread((OSFrame)parent, oldOSName, newOS, "OS has been modified")).start();
                                }
                            });
                        frame.buttons[1] = new JButton("Reset");
                        ((JButton)(frame.buttons[1])).addActionListener(new AActionListener(frame) {
                                public void actionPerformed(ActionEvent ev) {
                                    ((OSFrame)parent).osNameF.setText(((OSFrame)parent).osName);
                                    ((OSFrame)parent).osCommentF.setText(((OSFrame)parent).osComment);
                                }
                            });

                        frame.buttons[2] = new JButton("Cancel");
                        ((JButton)(frame.buttons[2])).addActionListener(new AActionListener(frame) {
                                public void actionPerformed(ActionEvent ev) {
                                    ((OSFrame)parent).modifyDialogWin.dispose();
                                }
                            });

                        JOptionPane modDialog =
                            new JOptionPane(panel, JOptionPane.PLAIN_MESSAGE, JOptionPane.YES_NO_CANCEL_OPTION, null, frame.buttons);
                        modifyDialogWin = modDialog.createDialog(parent, "Modify OS");
                        modifyDialogWin.show();

                    } catch(Exception exx) {
                        JOptionPane.showMessageDialog(parent,
                                                      exx.getMessage(), "Error", JOptionPane.ERROR_MESSAGE);
                        return;
                    }
                }
            });

        tool_bar.removeAll();
        tool_bar.add(closeB);
        this.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
        this.pack();
        this.setSize(800, 600);
        Dimension scrnsize = Toolkit.getDefaultToolkit().getScreenSize();
        setLocation( (int)((scrnsize.getWidth()-getWidth())/2),
                     (int)((scrnsize.getHeight()-getHeight())/2) );

        (new Thread(this)).start();
    }

    public void run() {
        try {
            try {
                MainWindow.loadOSes();
                osList = MainWindow.getOSes();
            } catch (java.rmi.NoSuchObjectException exx) {
                X.handleTimeout();

            } catch (java.rmi.MarshalException exx) {
                X.handleTimeout();

            } catch(Exception exx) {
                label.setText("Failed to load list of OSes.");
                label.setForeground(Color.red);
                Utils.warn(exx.toString());
                return;
            }

            osPanel = new JPanel();
            current_panel = osPanel;
            current_panel.setBackground(Color.white);
            current_gb_layout = new GridBagLayout();
            current_panel.setLayout(current_gb_layout);

            current_gbc.fill = GridBagConstraints.HORIZONTAL;
            current_gbc.weightx = 1;
            current_gbc.weighty = 0;
            current_gbc.gridwidth = GridBagConstraints.REMAINDER;

            // empty row at the top
            XLabel(" ");
            current_gbc.weighty = 1;

            // two os lists
            current_gbc.gridwidth = 1;
            current_gbc.fill = GridBagConstraints.BOTH;
            XLabel(" ");

            java.util.List list = Arrays.asList(osList.keySet().toArray());
            Collections.sort(list, name_cmp);

            String[] oses = new String[osList.size()];
            Iterator it = list.iterator();
            int i = 0;
            while( it.hasNext() ) {
                oses[i++] = (String)it.next();
            }
            osList1 = new AJList(null);
            osList1.setListData(oses);
            osList1.setDragEnabled(false);
            osList1.addMouseListener(new MouseAdapter() {
                    public void mouseClicked(MouseEvent event) {
                        if( event.getClickCount() > 1 )
                            modB.doClick();
                    }
                });
            osList1.addKeyListener(new KeyAdapter() {
                    public void keyPressed(KeyEvent e) {
                        if( e.getKeyCode() == KeyEvent.VK_ENTER )
                            modB.doClick();
                        else if( e.getKeyCode() == KeyEvent.VK_DELETE )
                            delB.doClick();
                        else if( e.getKeyCode() == KeyEvent.VK_INSERT )
                            addB.doClick();
                    }
                });

            osList2 = new AJList(null);
            osList2.setListData(oses);
            osList2.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);

            JScrollPane scrollpane1 = new JScrollPane(osList1);
            JScrollPane scrollpane2 = new JScrollPane(osList2);

            current_gbc.gridwidth = 3;
            current_gb_layout.setConstraints(scrollpane1, current_gbc);
            current_panel.add(scrollpane1);

            current_gbc.gridwidth = 1;
            XLabel(" Becomes -> ");

            current_gbc.gridwidth = 3;
            current_gb_layout.setConstraints(scrollpane2, current_gbc);
            current_panel.add(scrollpane2);

            current_gbc.gridwidth = GridBagConstraints.REMAINDER;
            XLabel(" ");

            // empty row
            current_gbc.weighty = 0;
            current_gbc.gridwidth = GridBagConstraints.REMAINDER;
            XLabel(" ");

            // lots of buttons
            current_gbc.weighty = 0;
            current_gbc.gridwidth = 1;
            XLabel(" ");

            current_gb_layout.setConstraints(addB, current_gbc);
            current_panel.add(addB);

            current_gb_layout.setConstraints(modB, current_gbc);
            current_panel.add(modB);

            current_gb_layout.setConstraints(delB, current_gbc);
            current_panel.add(delB);

            XLabel(" ");

            current_gb_layout.setConstraints(becomesB, current_gbc);
            current_panel.add(becomesB);

            current_gbc.gridwidth = GridBagConstraints.REMAINDER;
            XLabel(" ");

            // empty row
            current_gbc.weighty = 0;
            current_gbc.gridwidth = GridBagConstraints.REMAINDER;
            XLabel(" ");

            central_panel.removeAll();
            central_panel.setLayout(new BorderLayout(1, 1));
            central_panel.add(current_panel);
            central_panel.revalidate();

            scrollpane.validate();
            scrollpane.repaint();

            current_panel.validate();
            current_panel.repaint();

            THIS.validate();

            osList1.requestFocus();

        } catch (Exception ex) {
            Utils.warn(ex.toString());
        }
    }
}
