-- NetDB_LimitedName.sql --- functions dealing with limited names.

create or replace package body NetDB_LimitedName as

    -- See if a name can be used in a limited domain.
    function is_limited (p_name in varchar) return boolean
    as
        v_matches int := 0;
    begin
        select count (*) into v_matches from LimitedNames where regexp_like (p_name, name);

        if (v_matches > 0) then
            return true;
        else
            return false;
        end if;
    end is_limited;

end NetDB_LimitedName;
/
