-- NetDB_Access.sql --- Access package spec

create or replace package NetDB_Access as

    function check_access ( p_user_id               in int,
                            p_access_type           in varchar,
                            p_record_id             in int     := null,
                            p_check_all_record_flag in boolean := true ) return boolean;

    procedure has_access_or_die ( p_user_id               in int,
                                  p_record_type           in varchar,
                                  p_record_id             in int     := null,
                                  p_check_all_record_flag in boolean := true );

    function verify_or_die ( p_access_id in int     := null,
                             p_label     in varchar := null ) return int;

    function handle (p_access_id in int) return varchar;

    function master ( p_action         in varchar,
                      p_op_uid         in int     := null,
                      p_label          in varchar := null,
                      p_label_new      in varchar := null,
                      description      in varchar := null,
                      p_default_access in varchar := null,
                      p_display_label  in varchar := null ) return NetDB.ref_cursor;

end NetDB_access;
/

grant execute on NetDB_Access to netdb_execute;
