-- NetDB_AdminTeam.sql --- contains functions related to  AdminTeam

create or replace package NetDB_AdminTeam
as
    procedure member ( p_action    in varchar,
                       p_op_uid    in int,
                       p_lock      in timestamp,
                       p_ateam_id  in int,
                       p_person_id in int );

    procedure org ( p_action   in varchar,
                    p_op_uid   in int,
                    p_lock     in timestamp,
                    p_ateam_id in int,
                    p_org_id   in int     := null,
                    p_org_name in varchar := null );

    procedure locked_or_die ( p_op_uid   in  int,
                              p_lock     in  timestamp,
                              p_ateam_id in  int );

    function handle (p_ateam_id in int) return varchar;

    function verify_or_die ( p_ateam_id in int     := null,
                             p_name     in varchar := null ) return int;

    function info (p_ateam_id in int) return result_set pipelined;

    function master ( p_action   in varchar,
                      p_op_uid   in int       := null,
                      p_lock     in timestamp := null,
                      p_ateam_id in int       := null,
                      p_name     in varchar   := null,
                      p_name_new in varchar   := null,
                      p_email    in varchar   := null,
                      p_phone    in varchar   := null,
                      p_comments in varchar   := null ) return NetDB.ref_cursor;
end NetDB_AdminTeam;
/

grant execute on NetDB_AdminTeam to netdb_execute;
