-- NetDB_DHCPoption.sql --- NetDB_DHCPoption package  spec.

create or replace package NetDB_DHCPoption as

    procedure application_add ( p_op_uid       in int,
                                p_app_label    in varchar,
                                p_option_id    in int     := null,
                                p_option_label in varchar := null );

    procedure application_remove ( p_op_uid       in int,
                                   p_app_label    in varchar,
                                   p_option_id    in int     := null,
                                   p_option_label in varchar := null );

    procedure add ( p_op_uid       in int,
                    p_lock         in timestamp,
                    p_record_id    in int,
                    p_record_type  in varchar,
                    p_option_id    in int     := null,
                    p_option_label in varchar := null,
                    p_value        in varchar );

    procedure remove ( p_op_uid       in int,
                       p_lock         in timestamp,
                       p_record_id    in int,
                       p_record_type  in varchar,
                       p_option_id    in int     := null,
                       p_option_label in varchar := null );

    function verify_or_die ( p_option_id in int     := null,
                             p_label     in varchar := null ) return int;

    function handle (p_option_id in int) return varchar;

    function master ( p_action    in varchar,
                      p_op_uid    in int       := null,
                      p_option_id in int       := null,
                      p_label     in varchar   := null,
                      p_label_new in varchar   := null,
                      p_datatype  in varchar   := null,
                      p_type      in varchar   := null ) return NetDB.ref_cursor;

end NetDB_DHCPoption;
/

grant execute on NetDB_DHCPoption to netdb_execute;
