-- NetDB_Domain.pkg --- Domain package spec.

create or replace package NetDB_Domain
as
    function can_use ( p_user_id   in int,
                       p_domain_id in int ) return boolean;

    function can_use_as_name ( p_user_id   in int,
                               p_domain_id in int ) return boolean;

    function is_limited (p_domain_id in int) return boolean;

    procedure locked_or_die ( p_op_uid    in int,
                              p_lock      in timestamp,
                              p_domain_id in int );

    function info (p_domain_id in int) return result_set pipelined;

    function verify_or_die ( p_domain_id in int     := null,
                             p_domain    in varchar := null ) return int;

    function handle (p_domain_id in int) return varchar;

    function master ( p_action     in varchar,
                      p_op_uid     in int       := null,
                      p_lock       in timestamp := null,
                      p_domain_id  in int       := null,
                      p_domain     in varchar   := null,
                      p_domain_new in varchar   := null,
                      p_comment    in varchar   := null,
                      p_limited    in int       := 1 ) return NetDB.ref_cursor;
end NetDB_Domain;
/

grant execute on NetDB_Domain to netdb_execute;
