-- NetDB_IPaddress.sql --- functions dealing with IP addresses

create or replace package NetDB_IPaddress as

    function reserve ( p_op_uid     in int,
                       p_start      in varchar,
                       p_count      in int     := 1,
                       p_exact      in int     := 0,
                       p_contiguous in int     := 0 ) return NetDB.ref_cursor;

    procedure accept ( p_op_uid        in int,
                       p_address       in varchar,
                       p_active        in int := 1,
                       p_PTRpref       in int := 0,
                       p_referent_id   in int,
                       p_lock          in timestamp,
                       p_referent_type in varchar );

    procedure cancel ( p_op_uid  in int,
                       p_address in varchar );

    function closest_name (p_ipaddress in varchar) return varchar;

    procedure locked_or_die ( p_op_uid     in int,
                              p_lock       in timestamp,
                              p_address_id in int );

    function info ( p_address_id       in int := null,
                    p_node_id          in int := null,
                    p_interface_id     in int := null,
                    p_address_space_id in int := null ) return result_set pipelined;

    function verify_or_die ( p_address_id in int     := null,
                             p_address    in varchar := null) return int;

    function handle ( p_address_id  in int,
                      user_readable in boolean := false ) return varchar;

    function master ( p_action           in varchar,
                      p_op_uid           in int       := null,
                      p_lock             in timestamp := null,
                      p_address_id       in int       := null,
                      p_address          in varchar   := null,
                      p_active           in int       := 1,
                      p_PTRpref          in int       := 0,
                      p_node_id          in int       := null,
                      p_interface_id     in int       := null,
                      p_address_space_id in int       := null ) return NetDB.ref_cursor;

end NetDB_IPaddress;
/

grant execute on NetDB_IPaddress to netdb_execute;
