-- NetDB_IPaddressSpace.sql --- functions related to IPaddressSpace table

create or replace package NetDB_IPaddressSpace as

    procedure move ( p_op_uid       in int,
                     p_lock         in timestamp,
                     p_ias_id       in int     := null,
                     p_prefix       in varchar := null,
                     p_network_id   in int     := null,
                     p_network_name in varchar := null,
                     p_net_lock     in timestamp );

    function is_MidRes (p_address in varchar) return boolean;
    function after_MidRes (p_address in varchar) return varchar;

    function containing (p_ip in varchar) return int;

    procedure validate_join ( p_prefix     in varchar := null,
                              p_network_id in int     := null,
                              p_network    in varchar := null );

    procedure validate_split (p_prefix in varchar);

    function get_parent_id (p_ias_id in int) return int;

    procedure locked_or_die ( p_op_uid in int,
                              p_lock   in timestamp,
                              p_ias_id in int );

    function info (p_ias_id in int) return result_set pipelined;

    function list (p_user_id in int := null) return result_set pipelined;

    function verify_or_die ( p_ias_id in int     := null,
                             p_prefix in varchar := null ) return int;

    function handle ( p_ias_id      in int,
                      user_readable in boolean := false) return varchar;

    function master ( p_action     in varchar,
                      p_op_uid     in int       := null,
                      p_lock       in timestamp := null,
                      p_ias_id     in int       := null,
                      p_prefix     in varchar   := null,
                      p_network_id in int       := null,
                      p_net_lock   in timestamp := null,  -- The network lock, when updating.
                      p_comment    in varchar   := null,
                      p_lowres     in int       := null,
                      p_highres    in int       := null ) return NetDB.ref_cursor;

end NetDB_IPaddressSpace;
/

grant execute on NetDB_IPaddressSpace to netdb_execute;
