-- NetDB_Interface.sql --- contains functions related to interfaces

create or replace package NetDB_Interface as

    function get_parent_id (p_intfc_id in int) return int;

    procedure locked_or_die ( p_op_uid   in int,
                              p_lock     in timestamp,
                              p_intfc_id in int );

    function verify_or_die ( p_intfc_id   in int     := null,
                             p_HW_address in varchar := null ) return int;

    function handle (p_intfc_id in int) return varchar;

    function master ( p_action      in varchar,
                      p_op_uid      in int       := null,
                      p_lock        in timestamp := null,
                      p_intfc_id    in int       := null,
                      p_hw_addr     in varchar   := null,
                      p_hw_addr_new in varchar   := null,
                      p_type        in varchar   := null,
                      p_node_id     in int       := null,
                      p_use_roam    in int       := null,
                      p_use_dhcp    in int       := null,
                      p_comment     in varchar   := null ) return NetDB.ref_cursor;

end NetDB_Interface;
/

grant execute on NetDB_Interface to netdb_execute;
