-- NetDB_Network.pkg --- Network package spec.

create or replace package NetDB_Network
as

    procedure location ( p_action      in varchar,
                         p_op_uid      in int,
                         p_lock        in timestamp,
                         p_network_id  in int,
                         p_location_id in int );

    procedure locked_or_die ( p_op_uid     in int,
                              p_lock       in timestamp,
                              p_network_id in int );

    function info (p_net_id in int) return result_set pipelined;

    function verify_or_die ( p_network_id in int     := null,
                             p_network    in varchar := null) return int;

    function handle (p_network_id in int) return varchar;

    function master ( p_action  in varchar,
                      p_op_uid  in int       := null,
                      p_lock    in timestamp := null,
                      p_net_id  in int       := null,
                      p_network in varchar   := null,
                      p_service in varchar   := null,
                      p_comment in varchar   := null ) return NetDB.ref_cursor;

end NetDB_Network;
/

grant execute on NetDB_Network to netdb_execute;
