-- NetDB_Organization.sql --- contains functions related to Organization table

create or replace package NetDB_Organization as

    procedure consultant ( p_action    in varchar,
                           p_op_uid    in int,
                           p_person_id in int,
                           p_org_id    in int     := null,
                           p_org_name  in varchar := null,
                           p_primary   in int     := 0 );

    function info (p_org_id in int) return result_set pipelined;

    function verify_or_die ( p_org_id in int     := null,
                             p_name   in varchar := null ) return int;

    function handle (p_org_id in int) return varchar;

    function master ( p_action   in varchar,
                      p_op_uid   in int     := null,
                      p_org_id   in int     := null,
                      p_name     in varchar := null,
                      p_name_new in varchar := null,
                      p_reg_id   in varchar := null ) return NetDB.ref_cursor;

end NetDB_Organization;
/

grant execute on NetDB_Organization to netdb_execute;
