-- NetDB_State.sql --- State package spec.

create or replace package NetDB_State as

    function check_access ( p_user_id in int,
                            p_state   in varchar ) return boolean;

    procedure has_access_or_die ( p_user_id in int,
                                  p_state   in varchar );

    function verify_or_die (p_state in varchar) return varchar;

    function master ( p_action       in varchar,
                      p_op_uid       in int     := null,
                      p_state        in varchar := null,
                      p_state_new    in varchar := null,
                      p_rank         in int     := null,
                      p_denyDHCP     in int     := null,
                      p_denyDNS      in int     := null,
                      p_description  in varchar := null,
                      p_access_group in varchar := null ) return NetDB.ref_cursor;

end NetDB_State;
/

grant execute on NetDB_State to netdb_execute;
