-- bind-mx.sql --- sql to generate DNS mx records from NetDB

-- MX records

select MX.name, 'MX', MXrecord.preference,
       Rec.name, lower(Domain.domain), Domain.domain
  from Name MX, Name Rec, MXrecord, Domain
 where MX.id = MXrecord.sent_to
   and MX.domain = (select id from Domain where lower(domain) = '$domain')
   and MXrecord.received_by = Rec.id
   and Rec.domain = Domain.id;

-- Mail may be sent to the domain name

select MX.fullname || '.', 'MX', MXrecord.preference,
       Rec.name, lower(Domain.domain), Domain.domain
  from Name MX, Name Rec, MXrecord, Domain
 where lower(MX.fullname) = '$domain'
   and MX.id = MXrecord.sent_to
   and MXrecord.received_by = Rec.id
   and Rec.domain = Domain.id
   and '$dodomain' = 'yes' and instr('$domain','.') != 0;

