-- AdminTeam.sql --- node administration team

create table AdminTeam
(
    id           int           PRIMARY KEY, -- synthetic key
    name         varchar(64)   NOT NULL,    -- team name
    email        varchar(256)  NOT NULL,
    phone        varchar(32)   NOT NULL,
    created_by   int           NOT NULL references Person,
    modified_by  int           NOT NULL references Person,
    created      timestamp(3)  NOT NULL,
    modified     timestamp(3)  NOT NULL,
    locked_by    int,
    locked       timestamp(3),
    comments     varchar(256)
);

create sequence adminteam_id_seq nocache;

create unique index adminteam_lower_name_idx on AdminTeam (lower(name));

grant select on AdminTeam to netdb_select;

