-- IPaddress.sql --- IP addresses

create table IPaddress
(
    id              int           PRIMARY KEY,
    IPaddress       varchar(39)   UNIQUE    NOT NULL,
    IPaddress_txt   varchar(39)             NOT NULL,
    active          numeric(1)    default 1 NOT NULL,
    PTRpref         numeric(1)    default 0 NOT NULL,
    IPCnode         int           references Node           on delete cascade,
    interface       int           references Interface      on delete cascade,
    IPaddressSpace  int           references IPaddressSpace on delete cascade,
    reserved_by     int           references Person         on delete SET NULL,
    reserved        timestamp(3)
);

create sequence ipaddress_id_seq;

create index ipaddress_txt_idx          on IPaddress (IPaddress_txt);
create index ipaddress_ipcnode_idx      on IPaddress (IPCnode);
create index ipaddress_interface_idx    on IPaddress (interface);
create index ipaddress_addressspace_idx on IPaddress (IPaddressSpace);

grant select on IPaddress to netdb_select;

