-- IPaddressSpace.sql --- IP Subnets

create table IPaddressSpace
(
    id             int            PRIMARY KEY,  -- synthetic key
    network        int            NOT NULL references Network on delete cascade,
    comments       varchar(64),
    prefix         varchar(43)    NOT NULL,  -- prefix defining IP address space
    prefix_txt     varchar(43)    NOT NULL,
    address        varchar(39)    NOT NULL,  -- address space base address
    address_txt    varchar(39)    NOT NULL,
    broadcast      varchar(39)    NOT NULL,  -- address space broadcast address
    broadcast_txt  varchar(39)    NOT NULL,
    lowres         varchar(39)    NOT NULL,  -- lower reserved address boundary
    highres        varchar(39)    NOT NULL   -- upper reserved address boundary
);

create sequence ipaddressspace_id_seq;

create index ipas_network_idx     on IPaddressSpace (network);
create index ipas_prefix_idx      on IPaddressSpace (prefix);
create index ipas_prefix_txt_idx  on IPaddressSpace (prefix_txt);
create index ipas_address_txt_idx on IPaddressSpace (address_txt);
create index ipas_range_idx       on IPaddressSpace (address,broadcast);

grant select on IPaddressSpace to netdb_select;

