-- Interface.sql --- node interface

create table Interface
(
    id          int          PRIMARY KEY,
    type        varchar(32)  NOT NULL references InterfaceType,
    node        int          NOT NULL references Node on delete cascade,
    roam        numeric(1)   default 0 NOT NULL,
    DHCP        numeric(1)   default 1 NOT NULL,
    HW_address  varchar(32)  UNIQUE NULL,
    comments    varchar(64),
    constraint  must_use_dhcp_to_roam CHECK (DHCP = 1 or roam = 0),
    constraint  must_have_hw_for_dhcp CHECK (DHCP = 0 or HW_address is not null)    
);

create sequence interface_id_seq;

create index interface_node_idx   on Interface (node);
create index interface_lookup_idx on Interface (node,id);

grant select on Interface to netdb_select;
