-- MXrecord.sql --- DNS mail exchanger name information

create table MXrecord
(
    sent_to     int  NOT NULL references Name,
    received_by int  NOT NULL references Name on delete cascade,
    preference  int  NOT NULL CHECK (0 <= preference and preference <= 65535),
    PRIMARY KEY (sent_to, received_by)
);

create index mx_sent_idx on MXrecord (sent_to);
create index mx_recd_idx on MXrecord (received_by);

grant select on MXrecord to netdb_select;

