-- NodeType.sql --- node types (router, switch, server, etc.)

create table NodeType
(
    type         varchar(32)  PRIMARY KEY, -- publicly palatable string
    extkey       varchar(32)  NOT NULL,    -- never changing string (hardcoded into the middleware)
    plural       varchar(32)  NOT NULL,
    abbrev       varchar(8)   NOT NULL,
    rank         int          NOT NULL,
    description  varchar(64),
    accessgroup  int              NULL references AccessGroup
);

create unique index nodetype_lc_type_idx  on NodeType (lower(type));
create unique index nodetype_lc_label_idx on NodeType (lower(extkey));

grant select on NodeType to netdb_select;
