-- Owner.sql --- record ownership security group

create table Owner
(
    id           int            PRIMARY KEY,  -- synthetic key
    label        varchar(32)    NOT NULL,     -- name
    description  varchar(256),
    created_by   int            NOT NULL references Person,
    modified_by  int            NOT NULL references Person,
    created      timestamp(3)   NOT NULL,
    modified     timestamp(3)   NOT NULL,
    locked_by    int,
    locked       timestamp(3)
);

create sequence owner_id_seq nocache;

create unique index owner_lower_label_idx on Owner(lower(label));

grant select on Owner to netdb_select;

