-- Person.sql --- person registry cache

create table Person
(
    id            int          PRIMARY KEY,      -- synthetic key
    person_regid  varchar(32)  UNIQUE  NOT NULL, -- person registry key
    name          varchar(64)          NOT NULL, -- full name
    netid         varchar(128),                  -- uid
    email         varchar(64),                   -- email address
    phone         varchar(32),                   -- primary phone number
    active        numeric(1)           NOT NULL, -- still affiliated with Stanford?
    lastname      varchar(64),                   -- directory:sn
    directoryid   varchar(32)                    -- who(is) key
);

create sequence person_id_seq;

create index person_lower_name_idx on Person (lower(name));
create index person_netid_idx      on Person (netid);

grant select on Person to netdb_select;

