-- ResName.sql --- reserved names

create table ResName
(
    id          int          PRIMARY KEY,
    name        varchar(64)  NOT NULL CHECK (name = lower(name)),
    domain      int              NULL references Domain on delete cascade,
    modified_by int          NOT NULL references Person,
    modified    timestamp(3) NOT NULL
);

create sequence resname_id_seq nocache;

create        index resname_name_idx        on ResName (name);
create unique index resname_name_domain_idx on ResName (name, domain);

grant select on ResName to netdb_select;

