-- Users.sql --- NetDB users

create table Users
(
    id           int           PRIMARY KEY references Person,
    netid        varchar(128)  UNIQUE    NOT NULL, -- system maintained
    domain       int                     NOT NULL references Domain,
    owner        int                         NULL references Owner on delete SET NULL,
    prefix       varchar(43),
    active       numeric(1)    default 1 NOT NULL,
    all_groups   numeric(1)    default 0 NOT NULL,
    all_records  numeric(1)    default 0 NOT NULL,
    comments     varchar(256),
    last_login   timestamp(3),
    created_by   int                     NOT NULL references Person,
    modified_by  int                     NOT NULL references Person,
    created      timestamp(3)            NOT NULL,
    modified     timestamp(3)            NOT NULL,
    locked_by    int,
    locked       timestamp(3)
);

grant select on Users to netdb_select;

