-- Domain_b_u_r.sql --- Domain table before update trigger

create or replace trigger Domain_b_u_r
  before update of id, domain on Domain
  for each row
begin

    -- user must not change the value of the id column
    if (UPDATING('id') and :NEW.id != :OLD.id) then
        raise_application_error(NetDB.ex_id_must_not_change, 'ID values cannot be changed.');

    -- user must not update domain column
    elsif (UPDATING('domain')) then
        NetDB_Util.sysmaint_check('domain','domain');
    end if;

end;
/

