-- IPaddressSpace_a_d_s.sql --- IPaddressSpace table after delete trigger

create or replace trigger IPaddressSpace_a_d_s
  after delete on IPaddressSpace
declare
    I int;
begin

    -- only check address spaces if the network was deleted
    --   because we need to delete address spaces of existing
    --   networks for address space split and join operations
    delete deleted_as where network in (select id from Network);

    -- check each of the deleted IP address spaces...
    for space in (select prefix_txt, address, broadcast from deleted_as) loop
        -- for orphaned addresses
        select count(*) into I from IPaddress
         where IPaddress between space.address and space.broadcast
           and reserved is null;
        -- if there are any, deny the delete
        if I > 0 then
            NetDB_Util.throw_still_in_use('addressspace', space.prefix_txt);
        end if;
    end loop;

end;
/

