-- LNA_a_ud_s.sql --- LNA table after update or delete trigger

create or replace trigger LNA_a_ud_s
  after update or delete on LNA
declare
    N int := 0;
begin

    -- count LNAs without departments
    select count(*) into N
      from LNA right outer join Users on LNA.lna = Users.id
     where LNA.lna is null;

    -- if there are any, raise a ruckus
    if N > 0 then
        raise_application_error(NetDB.ex_user_must_be_LNA, 'A user must be associated with at least one department.');
    end if;

end;
/

