-- MXrecord_a_d_s.sql --- MXrecord table after delete trigger

create or replace trigger MXrecord_a_d_s
  after delete on MXrecord
declare
    I int;
begin

    -- check for name table MX names not in MXrecord
    select count(*) into I
        from MXrecord right outer join Name on MXrecord.sent_to = Name.id
       where Name.DNSlabel='MX' and Name.reserved_by is NULL and MXrecord.sent_to is null;

    -- if there are any, delete them
    if I > 0 then
        delete Name where id in
          (select Name.id
            from MXrecord right outer join Name on MXrecord.sent_to = Name.id
           where Name.DNSlabel='MX' and Name.reserved_by is NULL and MXrecord.sent_to is null);
    end if;

end;
/

