-- Name_a_u_s.sql --- Name table after update or delete trigger

create or replace trigger Name_a_u_s
  after update of name on Name
declare
    I int := 0;
    N int := 0;
    D varchar(256);
begin

    -- have any domains changed?
    select count(*) into N from updated_domains;

    -- if so, update their children
    if N > 0 then

        -- fill in updated_domains.fullname_lc
        update updated_domains set fullname_lc=(select lower(domain) from domain
                                                 where id=updated_domains.domain);

        -- think of the childern ...
        while N > 0 loop

            -- pick the sortest domain
            select min(length(domain)) into I from updated_domains;
            select min(fullname_lc) into D from updated_domains where length(domain)=I;

            -- delete this domain and children from updated_domains
            delete updated_domains where fullname_lc=D or fullname_lc like '%.'||D;

            -- update Domain.domain for this domain and its child domains
            update Domain set id=id where lower(domain)=D or lower(domain) like '%.'||D;

            -- update fullname and fullname_lc for all children
            update Name set id=id where fullname_lc like  '%.'||D;

            -- update counter
            select count(*) into N from updated_domains;
        end loop;

    end if;

end;
/

