-- Network_Owner_a_ud_s.sql --- Network_Owner table after update or delete trigger

create or replace trigger Network_Owner_a_ud_s
  after update or delete on Network_Owner
declare
    N int := 0;
begin

    -- count networks without owners
    select count(*) into N
      from Network_Owner right outer join Network on Network.id = Network_Owner.network
     where Network_Owner.owner is null;

    -- if there are any, raise a ruckus
    if N > 0 then
        raise_application_error(NetDB.ex_record_requires_group, 'Networks must be in at least one group.');
    end if;

end;
/

