-- Node_OS_a_ud_s.sql --- Node_OS table after update or delete trigger

create or replace trigger Node_OS_a_ud_s
  after update or delete on Node_OS
declare
    N int := 0;
begin

    -- count nodes without OSes
    select count(*) into N
      from Node_OS right outer join Node on Node.id = Node_OS.node
     where Node_OS.os is null;

    -- if there are any, raise a ruckus
    if N > 0 then
        raise_application_error(NetDB.ex_node_must_have_OS, 'Nodes must have at least one OS.');
    end if;

end;
/

