-- Users_Owner_a_ud_s.sql --- Users_Owner table after update or delete trigger

create or replace trigger Users_Owner_a_ud_s
  after update or delete on Users_Owner
declare
    N int := 0;
begin

    -- count active users without owners
    select count(*) into N
      from Users_Owner right outer join Users on Users.id = Users_Owner.userid
     where Users_Owner.owner is null
       and Users.active=1;

    -- if there are any, raise a ruckus
    if N > 0 then
        raise_application_error(NetDB.ex_record_requires_group, 'Active users must be in at least one group.');
    end if;

end;
/

