-- Users_b_iu_r.sql --- Users table before insert or update trigger

create or replace trigger Users_b_iu_r
  before insert or update on Users
  for each row
begin

    -- make sure the user is not setting netid column
    if INSERTING then
        NetDB_Util.sysmaint_check('netid',:NEW.netid);
    end if;

    -- always get netid from the Person table
    select netid into :NEW.netid from Person where id=:NEW.id;

    -- normalize prefix
    :NEW.prefix := IP.normalize(IP.network(:NEW.prefix));

end;
/

