savepoint before_tests;

begin
    begin
        dbms_output.put ('Verifying constraints...');

        update Node_NodeType set type = 'fake-type_that-is very_unlikely' where rownum = 1;

        dbms_output.put_line ('FAILED!');
    exception
        when NetDB.parent_does_not_exist then
            dbms_output.put_line ('OK');
    end;

    declare
        before int;
        after  int;
        existing_type NodeType.type%TYPE;
        test_type     NodeType.type%TYPE;
    begin
        dbms_output.put ('Verifying triggers...');

        begin -- in the event that all the types are too long to append something, skip the test.
            select type into existing_type from NodeType where length (type) <= 29 and rownum = 1;
            test_type := existing_type || '^_^';
        exception
            when no_data_found then
                dbms_output.put_line ('skipped (no suitable test data found)');
        end;

        if (test_type is not null) then
            select count (*) into before from Node_NodeType where type = existing_type;
            update NodeType set type = test_type            where type = existing_type;
            select count (*) into after  from Node_NodeType where type = test_type;

            if (before = after) then
                dbms_output.put_line ('OK');
            else
                dbms_output.put_line ('FAILED! (trigger did not function as expected)');
            end if;
        end if;
    exception
        when NetDB.children_exist then
            dbms_output.put_line ('FAILED! (trigger was not loaded)');
    end;
end;
/

rollback to before_tests;
