savepoint before_tests;

begin
    begin
        dbms_output.put ('Verifying constraints...');

        update Node set State = 'fake-state_that-is very_unlikely' where rownum = 1;

        dbms_output.put_line ('FAILED!');
    exception
        when NetDB.parent_does_not_exist then
            dbms_output.put_line ('OK');
    end;

    declare
        before int;
        after  int;
        existing_state State.state%TYPE;
        test_state     State.state%TYPE;
    begin
        dbms_output.put ('Verifying triggers...');

        begin -- in the event that all the states are too long to append something, skip the test.
            select state into existing_state from Node where length (state) <= 29 and rownum = 1;
            test_state := existing_state || '^_^';
        exception
            when no_data_found then
                dbms_output.put_line ('skipped (no suitable test data found)');
        end;

        if (test_state is not null) then
            select count (*) into before from Node where state = existing_state;
            update State set state = test_state    where state = existing_state;
            select count (*) into after  from Node where state = test_state;

            if (before = after) then
                dbms_output.put_line ('OK');
            else
                dbms_output.put_line ('FAILED! (trigger did not function as expected)');
            end if;
        end if;
    exception
        when NetDB.children_exist then
            dbms_output.put_line ('FAILED! (trigger was not loaded)');
    end;
end;
/

rollback to before_tests;
