-- FS_AddressSpaceInfo.sql --- view for network full search

create or replace view FS_AddressSpaceInfo as
    select IPaddressSpace.network    id,
           null                      IPaddress_txt,
           null                      location,
           null                      ip_active,
           null                      ip_name,
           null                      ip_domain,
           null                      ip_as_prefix,
           IPaddressSpace.prefix_txt as_prefix,
           case
                when DHCPoption.label is not null
                    then DHCPoption.label || '=' || IPaddressSpace_DHCPoptions.value
                else
                    null
           end as_dhcp_option,
           null                      net_dhcp_option,
           null                      comments,
           IPaddressSpace.comments   as_comments,
           to_char(IP.difference(IPaddressSpace.lowres,
                                 IPaddressSpace.address)) lowres,
           to_char(IP.difference(IPaddressSpace.broadcast,
                                 IPaddressSpace.highres)) highres,
           null                      as_owner,
           null                      name_id,
           null                      net_name,
           null                      net_domain,
           null                      dhcp_service,
           null                      owner,
           null                      mod_by_netid,
           null                      mod_by_name,
           null                      modified,
           null                      created_by_netid,
           null                      created_by_name,
           null                      created
      from IPaddressSpace
      left join IPaddressSpace_DHCPoptions
            on IPaddressSpace_DHCPoptions.IPaddressSpace = IPaddressSpace.id
      left join DHCPoption
            on DHCPoption.id = IPaddressSpace_DHCPoptions.DHCPoption;

grant select on FS_AddressSpaceInfo to netdb_view;
