-- FS_Domain.sql --- view for full search for domains.

create or replace view FS_Domain as
    select Domain.id,                Domain.domain,             Domain.comments,
           Domain.limited,           o1.label owner,            o2.label assignNamesIn,
           o3.label useAsName,       mp.netid mod_by_netid,     mp.name mod_by_name,
           Domain.modified modified, cp.netid created_by_netid, cp.name created_by_name,
           Domain.created created
    from Domain
    join Person cp       on cp.id               = Domain.created_by
    join Person mp       on mp.id               = Domain.modified_by
    join Domain_Owner    on Domain_Owner.domain = Domain.id
    join Owner o1        on o1.id               = Domain_Owner.owner
    left join Domain_assignNameIn on Domain_assignNameIn.domain = Domain.id
    left join Owner o2            on o2.id                      = Domain_assignNameIn.owner
    left join Domain_useAsName    on Domain_useAsName.domain    = Domain.id
    left join Owner o3            on o3.id                      = Domain_useAsName.owner;

grant select on FS_Domain to netdb_view;