-- FS_NameNode.sql --- view for node full search

create or replace view FS_NameNode as
    select Name.id       id, Name.name,      Name.domain,          Name.fullname,
           Name.fullname_lc, Name.label,     Name.DNSlabel,        Name.IPaddress,
           Name.aliasee,     Name.interface, Name.node,            Name.network,
           Name.reserved_by, Name.reserved,  Name.related_node node_id,
           case when IPAddress.interface is not null then 'ip'
                when IPAddress.ipcnode is not null   then 'ipc'
                else null
           end iptype
    from Name left join IPAddress on IPAddress.id = Name.IPaddress
    where related_node is not null;

grant select on FS_NameNode to netdb_view;
