-- FS_NodeIPaddress.sql --- view for node full search

create or replace view FS_NodeIPaddress as
    select coalesce(IPaddress.IPCnode, Interface.node) id, IPaddress.IPaddress,
           IPaddress.IPaddress_txt,                        IPaddress.active,
           Interface.HW_address,                           Interface.dhcp,
           Interface.roam,
           replace(DHCPoption.label, '#', '#hsh') || '#eql' || replace(Interface_DHCPoptions.value, '#', '#hsh') dhcp_option,
           IPaddress.PTRpref
      from IPaddress
      full join Interface             on Interface.id                    = IPaddress.interface
      left join Interface_DHCPoptions on Interface_DHCPoptions.interface = Interface.id
      left join DHCPoption            on DHCPoption.id                   = Interface_DHCPoptions.DHCPoption
     where IPaddress.interface is not null or IPaddress.IPCnode is not null or Interface.id is not null;

grant select on FS_NodeIPaddress to netdb_view;
