-- FS_NodeInfo.sql --- view for full search for nodes.

create or replace view FS_NodeInfo as
    select Node.id,
           null name_id,
           null name,
           null domain,
           null aliasee,
           null interface,
           null node,
           null IPaddress,
           null ip_name_interface,
           null mx_name,
           null mx_domain,
           null mx_received_by,
           null mx_pref,
           null ipc_address_txt,
           null ipc_active,
           null interface_id,
           null interface_hw,
           null interface_roam,
           null interface_dhcp,
           null dhcp_options,
           null ip_interface,
           null ip_address_txt,
           null PTRpref,
           null ip_active,
           Node_NodeType.type,
           Node.state,
           Location.name location,
           Node.room,
           Node.expiration,
           Organization.organization,
           Owner.label owner,
           Model.make || ' ' || Model.modelname make_and_model,
           Node_OS.os,
           nvl(Node.comments, ' ') comments,
           case
                when Node_Admin.person is not null
                    then coalesce(am.name, am.netid, ' ')
                when Node_Admin.adminteam is not null
                    then AdminTeam.name || ';'
                else
                    ' '
           end node_admin,
           case
                when NodeTag.label is null then ' '
                else NodeTag.label || '=' || NodeTag.value
           end tag,
           coalesce(up.name, up.netid, ' ') node_user,
           mp.netid      mod_by_netid,
           mp.name       mod_by_name,
           Node.modified modified,
           cp.netid      created_by_netid,
           cp.name       created_by_name,
           Node.created  created,
           Location.site,
           Location.code
      from Node
      left join Node_OS           on Node.id              = Node_OS.node
      left join NodeTag           on Node.id              = NodeTag.node
      left join Node_User         on Node.id              = Node_User.node
      left join Person up         on Node_User.person     = up.id
      left join Node_Admin        on Node.id              = Node_Admin.node
      left join AdminTeam         on Node_Admin.adminteam = AdminTeam.id
      left join Person am         on Node_Admin.person    = am.id
      left join Node_NodeType     on Node.id              = Node_NodeType.node
      join Model                  on Node.model           = Model.id
      join Location               on Node.location        = Location.id
      join Organization           on Node.organization    = Organization.id
      join Node_Owner             on Node.id              = Node_Owner.node
      join Owner                  on Node_Owner.owner     = Owner.id
      join Person cp              on cp.id                = Node.created_by
      join Person mp              on mp.id                = Node.modified_by;

grant select on FS_NodeInfo to netdb_view;
