-- FS_NodeInfoIPC.sql --- view for full search for nodes.

create or replace view FS_NodeInfoIPC as
    select Node.id,
           null name_id,
           null name,
           null domain,
           null aliasee,
           null interface,
           null node,
           null IPaddress,
           null ip_name_interface,
           null mx_name,
           null mx_domain,
           null mx_received_by,
           null mx_pref,
           ipc.IPaddress_txt ipc_address_txt,
           decode(ipc.active, null, null, decode(ipc.active, 1, 'Yes', 'No')) ipc_active,
           null interface_id,
           null interface_hw,
           null interface_roam,
           null interface_dhcp,
           null dhcp_options,
           null ip_interface,
           null ip_address_txt,
           null PTRpref,
           null ip_active,
           null type,
           null state,
           null location,
           null room,
           null expiration,
           null organization,
           null owner,
           null make_and_model,
           null os,
           null comments,
           null node_admin,
           null tag,
           null node_user,
           null mod_by_netid,
           null mod_by_name,
           null modified,
           null created_by_netid,
           null created_by_name,
           null created,
           null site,
           null code
      from Node
      left join IPaddress ipc on Node.id = ipc.IPCnode;

grant select on FS_NodeInfoIPC to netdb_view;
