-- FS_User.sql --- view for full search for users.

create or replace view FS_User as
    select Users.id,                     Users.netid,              UP.name,
           UP.phone,                     UP.email,                 Domain.domain def_domain,
           Users.prefix def_addr_space,  DefOwner.label def_group, Users.active,
           Users.last_login,             LNA.official,             Organization.organization,
           Cons.name cons_name,          Cons.netid cons_netid,    Owner.label owner,
           Users.all_groups,             Users.all_records,        AccessGroup.label access_group,
           AccessGroup.label access_dsp, Users.comments,           mp.netid mod_by_netid,
           mp.name mod_by_name,          Users.modified modified,  cp.netid created_by_netid,
           cp.name created_by_name,      Users.created created
    from Users
    join Person UP               on UP.id                               = Users.id
    join Person cp               on cp.id                               = Users.created_by
    join Person mp               on mp.id                               = Users.modified_by
    left join Domain             on Users.domain                        = Domain.id
    left join Owner DefOwner     on Users.owner                         = DefOwner.id
    left join LNA                on LNA.lna                             = Users.id
    left join Organization       on LNA.organization                    = Organization.id
    full join Consultant         on LNA.organization                    = Consultant.organization
    left join Person Cons        on Consultant.person                   = Cons.id
    join Users_Owner             on Users_Owner.userid                  = Users.id
    join Owner                   on Owner.id                            = Users_Owner.owner
    left join Users_AccessGroup  on Users_AccessGroup.userid            = Users.id
    left join AccessGroup        on Users_AccessGroup.accessgroup       = AccessGroup.id;

grant select on FS_User to netdb_view;
