/************************************************************************
 *
 * ATeamCommand.java - contains all constants for NetDB_AdminTeam.master
 *                     procedure call
 *
 * $Id: ATeamCommand.java,v 1.1.1.1 2006/06/30 23:38:08 priimak Exp $
 *
 *-----------------------------------------------------------------------
 * Copyright (c) 2001 Board of Trustees, Leland Stanford Jr. University
 ************************************************************************/
package stanford.netdb.lib;

import stanford.netdb.utils.*;
import java.lang.*;
import java.sql.*;

/** contains all constants for NetDB_AdminTeam.master procedure call */
abstract class ATeamCommand extends DBCall {

    public static final int ACTION_INDEX                = 1; // p_action
    public static final int ID_OP_USER_INDEX            = 2; // p_op_uid
    public static final int LOCKED_INDEX                = 3; // p_lock
    public static final int ATEAM_ID_INDEX              = 4; // p_ateam_id
    public static final int NAME_INDEX                  = 5; // p_name
    public static final int NEW_NAME_INDEX              = 6; // p_name_new
    public static final int EMAIL_INDEX                 = 7; // p_email
    public static final int PHONE_INDEX                 = 8; // p_phone
    public static final int COMMENT_INDEX               = 9; // p_comments

    public ATeamCommand(stanford.netdb.utils.Logger logger) {
        super(logger);
        db_call_type = ORA_FUN_IGNORE_RET_CALL;

        values = new Object[10];
        values[0]                       = ref_cursor;
        values[ACTION_INDEX]            = new Null(Types.VARCHAR);
        values[ID_OP_USER_INDEX]        = new Null(Types.NUMERIC);
        values[LOCKED_INDEX]            = new Null(Types.TIMESTAMP);
        values[ATEAM_ID_INDEX]          = new Null(Types.NUMERIC);
        values[NAME_INDEX]              = new Null(Types.VARCHAR);
        values[NEW_NAME_INDEX]          = new Null(Types.VARCHAR);
        values[EMAIL_INDEX]             = new Null(Types.VARCHAR);
        values[PHONE_INDEX]             = new Null(Types.VARCHAR);
        values[COMMENT_INDEX]           = new Null(Types.VARCHAR);
    }

    public String getSQL() {
        return proc_call_sql("NetDB_AdminTeam.master");
    }
} // end of class ATeamCommand
