/************************************************************************
 *
 * ATeamFullSearchCommand.java -
 *
 * $Id: ATeamFullSearchCommand.java,v 1.1.1.1 2006/06/30 23:38:08 priimak Exp $
 *
 *-----------------------------------------------------------------------
 * Copyright (c) 2003, Board of Trustees, Leland Stanford Jr. University
 ************************************************************************/
package stanford.netdb.lib;

import java.util.*;
import java.text.*;

class ATeamFullSearchCommand extends FullSearchCommand {

    public ATeamFullSearchCommand(stanford.netdb.utils.Logger logger,
                                  Hashtable search_params)
    {
        super(logger, search_params);
    }

    public String getSearchSQL() throws Exception {
        String sql =
            "SELECT id \"ID\", name \"handle\""+
            (n2s(search_params.get("displayOrder.txt.1.Name")      ).equals("-1")?"":", name \"Name\"")+
            (n2s(search_params.get("displayOrder.txt.2.Department")).equals("-1")?"":", organization \"Department\"")+
            (n2s(search_params.get("displayOrder.txt.3.Group")     ).equals("-1")?"":", owner \"Group\"")+
            (n2s(search_params.get("displayOrder.txt.4.Member")    ).equals("-1")?"":
             ", decode(member_name||member_netid, null, null, member_name || '(' || member_netid || ')') \"Member\"")+
            (n2s(search_params.get("displayOrder.txt.5.Email")    ).equals("-1")?"":", email \"Email\"")+
            (n2s(search_params.get("displayOrder.txt.6.Phone")    ).equals("-1")?"":", phone \"Phone\"")+
            (n2s(search_params.get("displayOrder.txt.7.Comment")   ).equals("-1")?"":", nvl(comments, ' ') \"Comment\"")+
            modBlock(search_params)+
            " FROM "+search_params.get("fs.table")+
            " WHERE ID IN ( SELECT unique(id) FROM ";

        // fill in display order vector
        Vector displayOrder = new Vector();
        init_result(search_params, displayOrder, "Admin Teams");

        // go over displayOrder.XXX parameters and assemble displayOrder Vector
        assmDisplayOrder(displayOrder, search_params);

        // continue with assembling sql 'where' clause
        sql += assmCommonSQL(search_params) + " ) ";

        return sql;
    }
}
