/************************************************************************
 *
 * ATeamLockUnLockCommand.java - db call pAdminTeam 'lock/unlock'
 *
 * $Id: ATeamLockUnLockCommand.java,v 1.1.1.1 2006/06/30 23:38:08 priimak Exp $
 *
 *-----------------------------------------------------------------------
 * Copyright (c) 2003, Board of Trustees, Leland Stanford Jr. University
 ************************************************************************/
package stanford.netdb.lib;

import java.lang.*;
import java.util.*;
import java.sql.*;

/** db call pAdminTeam 'lock/unlock' */
class ATeamLockUnLockCommand extends ATeamCommand {

    public static final String LOCK_ACTION   = "lock";
    public static final String UNLOCK_ACTION = "unlock";

    public ATeamLockUnLockCommand(stanford.netdb.utils.Logger logger,
                                 String action,
                                 String ateamName,
                                 int id,
                                 Timestamp tm,
                                 Integer op_uid) {
        super(logger);
        if( action == LOCK_ACTION )
            db_call_type = ORA_FUN_CALL;
        values[ACTION_INDEX] = action;
        if( ateamName == null )
            values[ATEAM_ID_INDEX] = new Integer(id);
        else
            values[NAME_INDEX] = ateamName;

        values[ID_OP_USER_INDEX] = op_uid;
        if( tm != null )
            values[LOCKED_INDEX] = tm;
    }
}
