/************************************************************************
 *
 * AddrSpaceCommand.java - contains all constants for
 *                         NetDB_IPaddressSpace.master procedure call
 *
 * $Id: AddrSpaceCommand.java,v 1.1.1.1 2006/06/30 23:38:08 priimak Exp $
 *
 *-----------------------------------------------------------------------
 * Copyright (c) 2002, Board of Trustees, Leland Stanford Jr. University
 ************************************************************************/
package stanford.netdb.lib;

import stanford.netdb.utils.*;
import java.lang.*;
import java.sql.*;

/** contains all constants for NetDB_IPaddressSpace.master procedure call */
abstract class AddrSpaceCommand extends DBCall {

    protected Timestamp lock;

    public static final int ACTION_INDEX     = 1;  // p_action
    public static final int ID_OP_USER_INDEX = 2;  // p_op_uid
    public static final int LOCKED_INDEX     = 3;  // p_lock
    public static final int ID_AS_INDEX      = 4;  // p_ias_id
    public static final int PREFIX_INDEX     = 5;  // p_prefix
    public static final int ID_NETWORK_INDEX = 6;  // p_network_id
    public static final int NET_LOCK_INDEX   = 7;  // p_net_lock
    public static final int COMMENT_INDEX    = 8;  // p_comment
    public static final int LOWRES_INDEX     = 9;  // p_lowres
    public static final int HIGHRES_INDEX    = 10; // p_highres

    public AddrSpaceCommand(stanford.netdb.utils.Logger logger) {
        super(logger);
        values = new Object[11];

        values[0]                = ref_cursor;
        values[ACTION_INDEX]     = new Null(Types.VARCHAR);
        values[ID_OP_USER_INDEX] = new Null(Types.NUMERIC);
        values[LOCKED_INDEX]     = new Null(Types.TIMESTAMP);
        values[ID_AS_INDEX]      = new Null(Types.NUMERIC);
        values[PREFIX_INDEX]     = new Null(Types.VARCHAR);
        values[ID_NETWORK_INDEX] = new Null(Types.NUMERIC);
        values[NET_LOCK_INDEX]   = new Null(Types.TIMESTAMP);
        values[COMMENT_INDEX]    = new Null(Types.VARCHAR);
        values[LOWRES_INDEX]     = new Null(Types.VARCHAR);
        values[HIGHRES_INDEX]    = new Null(Types.VARCHAR);
    }

    public String getSQL() {
        return proc_call_sql("NetDB_IPaddressSpace.master");
    }
}
