/************************************************************************
 *
 * AddrSpacePrefix.java - IP.text(NetDB_IPaddressSpace.handle(containing(...)))
 *
 * $Id: AddrSpacePrefix.java,v 1.1.1.1 2006/06/30 23:38:08 priimak Exp $
 *
 *-----------------------------------------------------------------------
 * Copyright (c) 2006, Board of Trustees, Leland Stanford Jr. University
 ************************************************************************/
package stanford.netdb.lib;

import java.lang.*;
import java.sql.*;

/** db call IP.text(NetDB_IPaddressSpace.handle(containing(...))) */
class AddrSpacePrefix extends DBCall {

    public static final int IP_INDEX = 1;  // p_ip

    public AddrSpacePrefix(stanford.netdb.utils.Logger logger, String ip) {
        super(logger);

        db_call_type     = ORA_FUN_IGNORE_RET_CALL;
        values           = new Object[2];
        values[0]        = new OutParam(Types.VARCHAR);
        values[IP_INDEX] = ip;
    }

    public String getSQL() {
        return proc_call_sql("$(SCHEMA)IP.text($(SCHEMA)NetDB_IPaddressSpace.handle("+
                             "$(SCHEMA)NetDB_IPaddressSpace.containing");
    }
}
