/************************************************************************
 *
 * AddrSpaceVerifyCommand.java - db call NetDB_IPaddressSpace.validate_join
 *
 * $Id: AddrSpaceVerifyCommand.java,v 1.1.1.1 2006/06/30 23:38:08 priimak Exp $
 *
 *-----------------------------------------------------------------------
 * Copyright (c) 2002, Board of Trustees, Leland Stanford Jr. University
 ************************************************************************/
package stanford.netdb.lib;

import stanford.netdb.utils.*;
import java.lang.*;
import java.sql.*;

/** db call NetDB_IPaddressSpace.validate_join */
class AddrSpaceVerifyCommand extends DBCall {

    public static final int PREFIX_INDEX       = 0; // p_prefix
    public static final int NETWORK_ID_INDEX   = 1; // p_network_id
    public static final int NETWORK_NAME_INDEX = 2; // p_network

    public AddrSpaceVerifyCommand(stanford.netdb.utils.Logger logger, String prefix, Integer idNet)
    {
        super(logger);
        db_call_type = ORA_PROC_CALL;

        values = new Object[3];
        values[PREFIX_INDEX]       = prefix;
        values[NETWORK_ID_INDEX]   = idNet;
        values[NETWORK_NAME_INDEX] = new Null(Types.VARCHAR);
    }

    public String getSQL() {
        return proc_call_sql("NetDB_IPaddressSpace.validate_join");
    }
}
