/************************************************************************
 *
 * DHCPOptionCommand.java - db call NetDB_DHCPoption.master
 *
 * $Id: DHCPOptionCommand.java,v 1.1.1.1 2006/06/30 23:38:08 priimak Exp $
 *
 *-----------------------------------------------------------------------
 * Copyright (c) 2003, Board of Trustees, Leland Stanford Jr. University
 ************************************************************************/
package stanford.netdb.lib;

import stanford.netdb.utils.*;
import java.lang.*;
import java.util.*;
import java.sql.*;

/** base class for all call to NetDB_DHCP.options */
class DHCPOptionCommand extends DBCall {

    public static final int ACTION_INDEX                = 1; // p_action
    public static final int ID_OP_USER_INDEX            = 2; // p_op_uid
    public static final int ID_DHCP_OPTION_INDEX        = 3; // p_option_id
    public static final int LABEL_INDEX                 = 4; // p_label
    public static final int NEW_LABEL_INDEX             = 5; // p_label_new
    public static final int DATA_TYPE_INDEX             = 6; // p_datatype
    public static final int TYPE_INDEX                  = 7; // p_type

    public static final String DELETE_ACTION            = "delete";
    public static final String INSERT_ACTION            = "insert";
    public static final String UPDATE_ACTION            = "update";
    public static final String LIST_ACTION              = "list";

    public DHCPOptionCommand(stanford.netdb.utils.Logger logger, String action) {
        super(logger);
        values = new Object[8];
        values[0]                       = ref_cursor;
        values[ACTION_INDEX]            = action;
        values[ID_OP_USER_INDEX]        = new Null(Types.NUMERIC);
        values[ID_DHCP_OPTION_INDEX]    = new Null(Types.NUMERIC);
        values[LABEL_INDEX]             = new Null(Types.VARCHAR);
        values[NEW_LABEL_INDEX]         = new Null(Types.VARCHAR);
        values[DATA_TYPE_INDEX]         = new Null(Types.VARCHAR);
        values[TYPE_INDEX]              = new Null(Types.VARCHAR);
    }

    public String getSQL() {
        return proc_call_sql("NetDB_DHCPoption.master");
    }
}
