/************************************************************************
 *
 * DHCPServiceCommand.java - db call NetDB_DHCPservice.master
 *
 * $Id: DHCPServiceCommand.java,v 1.1.1.1 2006/06/30 23:38:08 priimak Exp $
 *
 *-----------------------------------------------------------------------
 * Copyright (c) 2002, Board of Trustees, Leland Stanford Jr. University
 ************************************************************************/
package stanford.netdb.lib;

import stanford.netdb.utils.*;
import java.lang.*;
import java.sql.*;

/** base class for all db calls to NetDB_DHCPservice.master */
abstract class DHCPServiceCommand extends DBCall {

    public static final int ACTION_INDEX                = 1;  // p_action
    public static final int ID_OP_USER_INDEX            = 2;  // p_op_uid
    public static final int SERVICE_ID_INDEX            = 3;  // p_service_id
    public static final int LABEL_INDEX                 = 4;  // p_label
    public static final int LABEL_NEW_INDEX             = 5;  // p_label_new
    public static final int DESC_INDEX                  = 6;  // p_description

    public DHCPServiceCommand(stanford.netdb.utils.Logger logger) {
        super(logger);
        values = new Object[7];
        values[0]                       = ref_cursor;
        values[ACTION_INDEX]            = new Null(Types.VARCHAR);
        values[ID_OP_USER_INDEX]        = new Null(Types.VARCHAR);
        values[SERVICE_ID_INDEX]        = new Null(Types.NUMERIC);
        values[LABEL_INDEX]             = new Null(Types.VARCHAR);
        values[LABEL_NEW_INDEX]         = new Null(Types.VARCHAR);
        values[DESC_INDEX]              = new Null(Types.VARCHAR);
    }

    public String getSQL() {
        return proc_call_sql("NetDB_DHCPservice.master");
    }
}
