/************************************************************************
 *
 * DepartmentCommand.java - base class for NetDB_Organization.master
 *
 * $Id: DepartmentCommand.java,v 1.1.1.1 2006/06/30 23:38:08 priimak Exp $
 *
 *-----------------------------------------------------------------------
 * Copyright (c) 2002, Board of Trustees, Leland Stanford Jr. University
 ************************************************************************/
package stanford.netdb.lib;

import stanford.netdb.utils.*;
import java.lang.*;
import java.sql.*;

/** base class for db call NetDB_Organization.master */
abstract class DepartmentCommand extends DBCall {

    public static final int ACTION_INDEX                = 1;  // p_action
    public static final int ID_OP_USER_INDEX            = 2;  // p_op_uid
    public static final int DEPARTMENT_ID_INDEX         = 3;  // p_org_id
    public static final int DEPARTMENT_NAME_INDEX       = 4;  // p_name
    public static final int DEPARTMENT_NEW_NAME_INDEX   = 5;  // p_name_new
    public static final int DEPARTMENT_REG_ID_INDEX     = 6;  // p_reg_id

    public DepartmentCommand(stanford.netdb.utils.Logger logger) {
        super(logger);
        values = new Object[7];
        values[0]                               = ref_cursor;
        values[ACTION_INDEX]                    = new Null(Types.VARCHAR);
        values[ID_OP_USER_INDEX]                = new Null(Types.NUMERIC);
        values[DEPARTMENT_ID_INDEX]             = new Null(Types.NUMERIC);
        values[DEPARTMENT_REG_ID_INDEX]         = new Null(Types.VARCHAR);
        values[DEPARTMENT_NAME_INDEX]           = new Null(Types.VARCHAR);
        values[DEPARTMENT_NEW_NAME_INDEX]       = new Null(Types.VARCHAR);
    }

    public String getSQL() {
        return proc_call_sql("NetDB_Organization.master");
    }
}
