/************************************************************************
 *
 * DomainCommand.java - contains all constants for NetDB_Domain.master
 *                      procedure call
 *
 * $Id: DomainCommand.java,v 1.2 2006/10/04 20:32:22 priimak Exp $
 *
 *-----------------------------------------------------------------------
 * Copyright (c) 2001 Board of Trustees, Leland Stanford Jr. University
 ************************************************************************/
package stanford.netdb.lib;

import stanford.netdb.utils.*;
import java.lang.*;
import java.sql.*;

/** contains all constants for NetDB_Domain.master procedure call */
abstract class DomainCommand extends DBCall {

    protected Timestamp lock;

    public static final int ACTION_INDEX     = 1; // p_action
    public static final int ID_OP_USER_INDEX = 2; // p_op_uid
    public static final int LOCKED_INDEX     = 3; // p_lock
    public static final int ID_INDEX         = 4; // p_domain_id
    public static final int NAME_INDEX       = 5; // p_domain
    public static final int NEW_NAME_INDEX   = 6; // p_domain_new
    public static final int COMMENT_INDEX    = 7; // p_comment
    public static final int LIMITED_INDEX    = 8; // p_limited

    public DomainCommand(stanford.netdb.utils.Logger logger) {
        super(logger);
        db_call_type = ORA_FUN_IGNORE_RET_CALL;

        values = new Object[9];
        values[0]                = ref_cursor;
        values[ACTION_INDEX]     = new Null(Types.VARCHAR);
        values[ID_OP_USER_INDEX] = new Null(Types.NUMERIC);
        values[LOCKED_INDEX]     = new Null(Types.TIMESTAMP);
        values[ID_INDEX]         = new Null(Types.NUMERIC);
        values[NAME_INDEX]       = new Null(Types.VARCHAR);
        values[NEW_NAME_INDEX]   = new Null(Types.VARCHAR);
        values[COMMENT_INDEX]    = new Null(Types.VARCHAR);
        values[LIMITED_INDEX]    = new Null(Types.TINYINT);
    }

    public String getSQL() {
        return proc_call_sql("NetDB_Domain.master");
    }
}
