/************************************************************************
 *
 * DomainLockUnLockCommand.java - db call NetDB_Domain.master 'lock/unlock'
 *
 * $Id: DomainLockUnLockCommand.java,v 1.1.1.1 2006/06/30 23:38:09 priimak Exp $
 *
 *-----------------------------------------------------------------------
 * Copyright (c) 2003, Board of Trustees, Leland Stanford Jr. University
 ************************************************************************/
package stanford.netdb.lib;

import java.lang.*;
import java.sql.*;

/** db call NetDB_Domain.master 'lock/unlock' */
class DomainLockUnLockCommand extends DomainCommand {

    public static final String LOCK_ACTION   = "lock";
    public static final String UNLOCK_ACTION = "unlock";

    public DomainLockUnLockCommand(stanford.netdb.utils.Logger logger,
                                   String action, String domainName,
                                   Integer idDomain, Timestamp tm,
                                   Integer op_uid)
    {
        super(logger);
        if( action == LOCK_ACTION ) db_call_type = ORA_FUN_CALL;

        values[ACTION_INDEX]     = action;
        values[ID_OP_USER_INDEX] = op_uid;
        values[NAME_INDEX]       = o2v(domainName);
        values[ID_INDEX]         = o2n(idDomain, Types.NUMERIC);

        if( tm != null ) values[LOCKED_INDEX] = tm;
    }
}
