/************************************************************************
 *
 * FindAddrSpace.java -
 *
 * $Id: FindAddrSpace.java,v 1.1.1.1 2006/06/30 23:38:09 priimak Exp $
 *
 *-----------------------------------------------------------------------
 * Copyright (c) 2003, Board of Trustees, Leland Stanford Jr. University
 ************************************************************************/
package stanford.netdb.lib;

import java.lang.*;
import java.util.*;
import java.sql.*;

/** db call pFindAS 'lock/unlock' */
class FindAddrSpace extends DBCall {

    public static final int IP_STR_INDEX = 1;  // @strIPAddress

    public FindAddrSpace(stanford.netdb.utils.Logger logger, String ip) {
        super(logger);
        values                  = new Object[2];
        values[0]               = new OutParam(Types.NUMERIC);
        values[IP_STR_INDEX]    = ip;
    }

    public String getSQL() {
        return "{?= call pFindAS(?)}";
    }

    public Hashtable processResultSet(Hashtable res)
        throws Exception
    {
        if( res.get("errors") != null )
            return res;

        Hashtable result = new Hashtable();
        Vector result_sets = (Vector)res.get("result_sets");
        for( int i = 0; i < result_sets.size(); i++ ) {
            Hashtable result_set = (Hashtable)result_sets.elementAt(i);
            Vector rs = (Vector)result_set.get("data");

            // uncomment to see the row data
            //printRawData(result_set);

            for( int j = 0; j < rs.size(); j++ ) {
                Vector row = (Vector)rs.elementAt(j);
                Object as = row.elementAt(0); // AS
                if( as instanceof String )
                    result.put("addr. space", as);
            }
        }
        return result;
    }
}
