/************************************************************************
 *
 * GroupCommand.java - contains all constants for NetDB_Owner.master
 *                     procedure call
 *
 * $Id: GroupCommand.java,v 1.1.1.1 2006/06/30 23:38:09 priimak Exp $
 *
 *-----------------------------------------------------------------------
 * Copyright (c) 2001 Board of Trustees, Leland Stanford Jr. University
 ************************************************************************/
package stanford.netdb.lib;

import stanford.netdb.utils.*;
import java.lang.*;
import java.sql.*;

/** contains all constants for NetDB_Owner.master */
abstract class GroupCommand extends DBCall {

    public static final int ACTION_INDEX        = 1; // p_action
    public static final int OP_USER_INDEX       = 2; // p_op_uid
    public static final int LOCKED_INDEX        = 3; // p_lock
    public static final int OWNER_ID_INDEX      = 4; // p_owner_id
    public static final int NAME_INDEX          = 5; // p_name
    public static final int NEW_NAME_INDEX      = 6; // p_name_new
    public static final int DESCRIPTION_INDEX   = 7; // p_description

    public GroupCommand(stanford.netdb.utils.Logger logger) {
        super(logger);
        db_call_type = ORA_FUN_IGNORE_RET_CALL;

        values = new Object[8];
        values[0]                     = ref_cursor;
        values[ACTION_INDEX]          = new Null(Types.VARCHAR);
        values[OP_USER_INDEX]         = new Null(Types.NUMERIC);
        values[NAME_INDEX]            = new Null(Types.VARCHAR);
        values[NEW_NAME_INDEX]        = new Null(Types.VARCHAR);
        values[OWNER_ID_INDEX]        = new Null(Types.NUMERIC);
        values[DESCRIPTION_INDEX]     = new Null(Types.VARCHAR);
        values[LOCKED_INDEX]          = new Null(Types.TIMESTAMP);
    }

    public String getSQL() {
        return proc_call_sql("NetDB_Owner.master");
    }
}
