/************************************************************************
 *
 * GroupInsertCommand.java - db call pOwner 'insert'
 *
 * $Id: GroupInsertCommand.java,v 1.1.1.1 2006/06/30 23:38:09 priimak Exp $
 *
 *-----------------------------------------------------------------------
 * Copyright (c) 2001 Board of Trustees, Leland Stanford Jr. University
 ************************************************************************/
package stanford.netdb.lib;

import java.util.*;
import java.lang.*;

/** db call pOwner 'insert' */
class GroupInsertCommand extends GroupCommand {

    public GroupInsertCommand(stanford.netdb.utils.Logger logger, Hashtable newGroup, Integer op_uid) {
        super(logger);
        db_call_type                  = ORA_FUN_CALL;
        values[ACTION_INDEX]          = "insert";
        values[OP_USER_INDEX]         = op_uid;
        String name = (String)newGroup.get("name");
        if( name.length() > 255 )
            name = name.substring(0, 254);
        values[NAME_INDEX] = name;

        String comment = (String)newGroup.get("comment");
        if( comment != null ) {
            if( comment.length() > 255 )
                comment = comment.substring(0, 254);
            values[DESCRIPTION_INDEX] = comment;
        }
    }
}
