/************************************************************************
 *
 * GroupLockUnLockCommand.java - pOwner lock/unlock db call
 *
 * $Id: GroupLockUnLockCommand.java,v 1.1.1.1 2006/06/30 23:38:09 priimak Exp $
 *
 *-----------------------------------------------------------------------
 * Copyright (c) 2003, Board of Trustees, Leland Stanford Jr. University
 ************************************************************************/
package stanford.netdb.lib;

import stanford.netdb.utils.*;
import java.lang.*;
import java.sql.*;

/** db call pOwner 'delete' */
class GroupLockUnLockCommand extends GroupCommand {

    public static final String LOCK_ACTION   = "lock";
    public static final String UNLOCK_ACTION = "unlock";

    public GroupLockUnLockCommand(stanford.netdb.utils.Logger logger,
                                  String action, String label,
                                  Integer idGroup, Timestamp tm,
                                  Integer op_uid)
    {
        super(logger);
        if( action == LOCK_ACTION )
            db_call_type        = ORA_FUN_CALL;

        values[0]               = ref_cursor;
        values[ACTION_INDEX]    = action;
        values[OP_USER_INDEX]   = op_uid;

        values[NAME_INDEX]      = o2v(label);
        values[OWNER_ID_INDEX]  = o2n(idGroup, Types.NUMERIC);

        if( tm != null )
            values[LOCKED_INDEX] = tm;
    }
}
