/************************************************************************
 *
 * GroupModifyCommand.java - db call call NetDB_Owner.master 'update'
 *
 * $Id: GroupModifyCommand.java,v 1.1.1.1 2006/06/30 23:38:09 priimak Exp $
 *
 *-----------------------------------------------------------------------
 * Copyright (c) 2001 Board of Trustees, Leland Stanford Jr. University
 ************************************************************************/
package stanford.netdb.lib;

import stanford.netdb.utils.*;
import java.util.*;
import java.lang.*;

/** db call call NetDB_Owner.master 'update' */
class GroupModifyCommand extends GroupCommand implements ComplexDBCall {

    public GroupModifyCommand(stanford.netdb.utils.Logger logger,
                              Hashtable oldGroup, Hashtable newGroup,
                              Integer op_uid) {
        super(logger);
        values[ACTION_INDEX]          = "update";
        values[OP_USER_INDEX]         = op_uid;
        String new_name               = (String)newGroup.get("name");
        if( new_name.length() > 255 )
            new_name = new_name.substring(0, 254);
        values[NEW_NAME_INDEX]        = new_name;

        String comment = (String)newGroup.get("comment");
        if( comment != null ) {
            if( comment.length() > 255 )
                comment = comment.substring(0, 254);
            values[DESCRIPTION_INDEX] = comment;
        }

        values[OWNER_ID_INDEX]        = new Integer((String)newGroup.get("id"));
        values[NAME_INDEX]            = oldGroup.get("name");
        values[LOCKED_INDEX]          = oldGroup.get("locked");
    }

    public Hashtable doIt(NetDBConnection con) throws NetDBException, Exception {
        Hashtable result = con.callDB(this);

        // check for errors
        Vector error_set = (Vector)result.get("errors");
        if( error_set != null && error_set.size() > 0 )
            return result;

        DBCall call = new GroupLockUnLockCommand(logger, GroupLockUnLockCommand.UNLOCK_ACTION,
                                                 (String)values[NEW_NAME_INDEX], null,
                                                 (java.sql.Timestamp)values[LOCKED_INDEX], (Integer)values[OP_USER_INDEX]);
        result = call.processResultSet(con.callDB(call));
        error_set = (Vector)result.get("errors");
        if( error_set == null || error_set.size() == 0 )
            ((NetDBii)logger).unregister_lock((java.sql.Timestamp)values[LOCKED_INDEX],
                                              new Integer(Constants.GROUP));

        return new Hashtable();
    }
}
