/************************************************************************
 *
 * IPAddressCancelCommand.java - db call NetDB_IPaddress.cancel
 *
 * $Id: IPAddressCancelCommand.java,v 1.1.1.1 2006/06/30 23:38:09 priimak Exp $
 *
 *-----------------------------------------------------------------------
 * Copyright (c) 2002, Board of Trustees, Leland Stanford Jr. University
 ************************************************************************/
package stanford.netdb.lib;

import java.lang.*;
import java.sql.*;

/** db call NetDB_IPaddress.cancel */
class IPAddressCancelCommand extends DBCall {

    public static final int ID_OP_USER_INDEX = 0;
    public static final int ADDRESS_INDEX    = 1;

    public IPAddressCancelCommand(stanford.netdb.utils.Logger logger,
                                  String ip, Integer op_uid) {
        super(logger);
        db_call_type = ORA_PROC_CALL;

        values                   = new Object[2];
        values[ID_OP_USER_INDEX] = op_uid;
        values[ADDRESS_INDEX]    = ip;
    }

    public String getSQL() {
        return proc_call_sql("NetDB_IPaddress.cancel");
    }
}
