/************************************************************************
 *
 * IPAddressCommand.java - base class for db call NetDB_IPaddress.master
 *
 * $Id: IPAddressCommand.java,v 1.2 2006/08/30 23:28:40 priimak Exp $
 *
 *-----------------------------------------------------------------------
 * Copyright (c) 2002, Board of Trustees, Leland Stanford Jr. University
 ************************************************************************/
package stanford.netdb.lib;

import stanford.netdb.utils.*;
import java.lang.*;
import java.sql.*;

/** base class for db call NetDB_IPaddress.master */
abstract class IPAddressCommand extends DBCall {

    public static final String DELETE_ACTION  = "delete";
    public static final String INFO_ACTION    = "info";
    public static final String UPDATE_ACTION  = "update";

    public static final int ACTION_INDEX      = 1;  // p_action
    public static final int ID_OP_USER_INDEX  = 2;  // p_op_uid
    public static final int LOCK_INDEX        = 3;  // p_lock
    public static final int ADDRESS_ID_INDEX  = 4;  // p_address_id
    public static final int ADDRESS_STR_INDEX = 5;  // p_address
    public static final int ACTIVE_INDEX      = 6;  // p_active
    public static final int PTR_PREF_INDEX    = 7;  // p_ptr_pref
    public static final int NODE_INDEX        = 8;  // p_node_id
    public static final int INTERFACE_INDEX   = 9;  // p_interface_id
    public static final int ADDR_SPACE_INDEX  = 10; // p_address_space_id

    public IPAddressCommand(stanford.netdb.utils.Logger logger) {
        super(logger);
        values = new Object[11];

        values[0]                 = ref_cursor;
        values[ACTION_INDEX]      = new Null(Types.VARCHAR);
        values[ID_OP_USER_INDEX]  = new Null(Types.NUMERIC);
        values[LOCK_INDEX]        = new Null(Types.TIMESTAMP);
        values[ADDRESS_ID_INDEX]  = new Null(Types.NUMERIC);
        values[ADDRESS_STR_INDEX] = new Null(Types.VARCHAR);
        values[ACTIVE_INDEX]      = new Null(Types.TINYINT);
        values[PTR_PREF_INDEX]    = new Null(Types.NUMERIC);
        values[NODE_INDEX]        = new Null(Types.NUMERIC);
        values[INTERFACE_INDEX]   = new Null(Types.NUMERIC);
        values[ADDR_SPACE_INDEX]  = new Null(Types.NUMERIC);
    }

    public String getSQL() {
        return proc_call_sql("NetDB_IPaddress.master");
    }
}
