/************************************************************************
 *
 * IPAddressUpdateCommand.java - db call NetDB_IPaddress.master 'update'
 *
 * $Id: IPAddressUpdateCommand.java,v 1.2 2006/08/30 23:28:40 priimak Exp $
 *
 *-----------------------------------------------------------------------
 * Copyright (c) 2006, Board of Trustees, Leland Stanford Jr. University
 ************************************************************************/
package stanford.netdb.lib;

import java.lang.*;
import java.sql.*;

/* db call NetDB_IPaddress.master 'update' */
class IPAddressUpdateCommand extends IPAddressCommand {

    public static final int IPC_NODE   = 1;
    public static final int INTERFACE  = 2;
    public static final int ADDR_SPACE = 3;

    public IPAddressUpdateCommand(stanford.netdb.utils.Logger logger,
                                  Timestamp lock, String ip,
                                  Boolean active, String ptr_pref,
                                  Integer op_uid) {
        super(logger);
        db_call_type = ORA_FUN_IGNORE_RET_CALL;

        values[ACTION_INDEX]       = UPDATE_ACTION;
        values[ID_OP_USER_INDEX]   = op_uid;
        values[LOCK_INDEX]         = lock;
        if( ptr_pref != null && ptr_pref.trim().length() > 0 )
            values[PTR_PREF_INDEX] = new Integer(ptr_pref);
        values[ADDRESS_STR_INDEX]  = ip;
        values[ACTIVE_INDEX]       = new Short( active.booleanValue()?"1":"0" );
    }
}
