/************************************************************************
 *
 * InterfaceInsertCommand.java - db call NetDB_Interface.master 'insert'
 *
 * $Id: InterfaceInsertCommand.java,v 1.1.1.1 2006/06/30 23:38:09 priimak Exp $
 *
 *-----------------------------------------------------------------------
 * Copyright (c) 2003, Board of Trustees, Leland Stanford Jr. University
 ************************************************************************/
package stanford.netdb.lib;

import java.lang.*;
import java.sql.*;

/** db call NetDB_Interface.master 'insert' */
class InterfaceInsertCommand extends InterfaceCommand {

    public InterfaceInsertCommand(stanford.netdb.utils.Logger logger, Timestamp lock,
                                  Integer nodeID, Boolean dhcp, Boolean roaming,
                                  String hw, String type, String comment, Integer op_uid)
    {
        super(logger);

        dhcp    = dhcp==null?Boolean.FALSE:dhcp;
        roaming = roaming==null?Boolean.FALSE:roaming;

        values[ACTION_INDEX]       = INSERT_ACTION;
        values[ID_OP_USER_INDEX]   = op_uid;
        values[LOCK_INDEX]         = lock;
        values[HW_ADDRESS_INDEX]   = o2v(hw);
        values[INTFC_TYPE_INDEX]   = type;
        values[NODE_ID_INDEX]      = nodeID;
        values[ROAMING_FLAG_INDEX] = new Integer(roaming.booleanValue()?1:0);
        values[DHCP_FLAG_INDEX]    = new Integer(dhcp.booleanValue()?1:0);
        values[COMMENT_INDEX]      = o2v(comment);
    }
}
