/************************************************************************
 *
 * InterfaceModifyCommand.java - db call NetDB_Interface.master 'update'
 *
 * $Id: InterfaceModifyCommand.java,v 1.1.1.1 2006/06/30 23:38:09 priimak Exp $
 *
 *-----------------------------------------------------------------------
 * Copyright (c) 2003, Board of Trustees, Leland Stanford Jr. University
 ************************************************************************/
package stanford.netdb.lib;

import java.lang.*;
import java.sql.*;

/** db call NetDB_Interface.master 'update' */
class InterfaceModifyCommand extends InterfaceCommand {

    public InterfaceModifyCommand(stanford.netdb.utils.Logger logger, Timestamp lock,
                                  Integer intfcID, Boolean dhcp, Boolean roaming,
                                  String hw, String type, String comment, Integer op_uid)
    {
        super(logger);
        db_call_type = ORA_FUN_IGNORE_RET_CALL;

        dhcp    = dhcp==null?Boolean.FALSE:dhcp;
        roaming = roaming==null?Boolean.FALSE:roaming;

        values[ACTION_INDEX]         = UPDATE_ACTION;
        values[ID_OP_USER_INDEX]     = op_uid;
        values[LOCK_INDEX]           = lock;
        values[INTFC_ID_INDEX]       = intfcID;
        values[NEW_HW_ADDRESS_INDEX] = o2v(hw);
        values[INTFC_TYPE_INDEX]     = type;
        values[ROAMING_FLAG_INDEX]   = new Integer(roaming.booleanValue()?1:0);
        values[DHCP_FLAG_INDEX]      = new Integer(dhcp.booleanValue()?1:0);
        values[COMMENT_INDEX]        = o2v(comment);
    }
}
