/************************************************************************
 *
 * LocationCommand.java - NetDB_Location.master call.
 *
 * $Id: LocationCommand.java,v 1.1.1.1 2006/06/30 23:38:09 priimak Exp $
 *
 *-----------------------------------------------------------------------
 * Copyright (c) 2002, Board of Trustees, Leland Stanford Jr. University
 ************************************************************************/
package stanford.netdb.lib;

import stanford.netdb.utils.*;
import java.lang.*;
import java.sql.*;

/** provides all constats for NetDB_Location.master call. */
abstract class LocationCommand extends DBCall {

    public static final int ACTION_INDEX        = 1; // p_action
    public static final int OP_USER_INDEX       = 2; // p_op_uid
    public static final int ID_INDEX            = 3; // p_location_id
    public static final int NAME_INDEX          = 4; // p_name
    public static final int NEW_NAME_INDEX      = 5; // p_name_name
    public static final int SITE_INDEX          = 6; // p_site
    public static final int CODE_INDEX          = 7; // p_code

    public LocationCommand(stanford.netdb.utils.Logger logger) {
        super(logger);
        values = new Object[8];
        values[0]                       = ref_cursor;
        values[ACTION_INDEX]            = new Null(Types.VARCHAR);
        values[OP_USER_INDEX]           = new Null(Types.NUMERIC);
        values[ID_INDEX]                = new Null(Types.NUMERIC);
        values[NAME_INDEX]              = new Null(Types.VARCHAR);
        values[NEW_NAME_INDEX]          = new Null(Types.VARCHAR);
        values[SITE_INDEX]              = new Null(Types.VARCHAR);
        values[CODE_INDEX]              = new Null(Types.VARCHAR);
    }

    public String getSQL() {
        return proc_call_sql("NetDB_Location.master");
    }
}
