/************************************************************************
 *
 * LocationInsertCommand.java - db call NetDB_Location.master 'insert'
 *
 * $Id: LocationInsertCommand.java,v 1.1.1.1 2006/06/30 23:38:09 priimak Exp $
 *
 *-----------------------------------------------------------------------
 * Copyright (c) 2002, Board of Trustees, Leland Stanford Jr. University
 ************************************************************************/
package stanford.netdb.lib;

import stanford.netdb.utils.*;
import java.lang.*;
import java.util.*;

/** NetDB_Location.master 'insert' */
class LocationInsertCommand extends LocationCommand {

    public LocationInsertCommand(stanford.netdb.utils.Logger logger,
                                 Hashtable location, Integer op_uid)
        throws NetDBException
   {
        super(logger);
        db_call_type = ORA_FUN_IGNORE_RET_CALL;

        values[ACTION_INDEX] = "insert";
        values[OP_USER_INDEX] = op_uid;
        values[NAME_INDEX] = location.get("location");

        Vector errors = new Vector();
        if( ((String)values[NAME_INDEX]).length() > 65 )
            errors.addElement("location field may not be longer than 65 characters");

        String site = (String)location.get("site");
        if( site == null ) site = "";
        values[SITE_INDEX] = site.trim();
        if( site.trim().length() > 16 )
            errors.addElement("site field may not be longer than 16 characters");

        String code = (String)location.get("code");
        if( code == null ) code = "";
        values[CODE_INDEX] = code.trim();
        if( code.trim().length() > 16 )
            errors.addElement("code field may not be longer than 16 characters");

        if( errors.size() > 0 )
            throw new NetDBException("", errors);
    }
}
