/************************************************************************
 *
 * LocationModifyCommand.java - db call pLocation 'update'
 *
 * $Id: LocationModifyCommand.java,v 1.1.1.1 2006/06/30 23:38:09 priimak Exp $
 *
 *-----------------------------------------------------------------------
 * Copyright (c) 2002, Board of Trustees, Leland Stanford Jr. University
 ************************************************************************/
package stanford.netdb.lib;

import stanford.netdb.utils.*;
import java.lang.*;
import java.util.*;

/** db call pLocation 'update' */
class LocationModifyCommand extends LocationCommand {

    /**
     * Constructor for LocationModifyCommand class.
     *
     * @param oldLoc     old location object
     * @param newLoc     old location object
     * @param regID      regID of operating user
     */
    public LocationModifyCommand(stanford.netdb.utils.Logger logger,
                                 Hashtable oldLoc, Hashtable newLoc,
                                 Integer op_uid)
        throws NetDBException
    {
        super(logger);
        db_call_type = ORA_FUN_IGNORE_RET_CALL;

        values[ACTION_INDEX]  = "update";
        values[OP_USER_INDEX] = op_uid;
        values[NAME_INDEX]    = oldLoc.get("location");

        Vector errors = new Vector();
        values[NEW_NAME_INDEX] = newLoc.get("location");
        if( ((String)values[NEW_NAME_INDEX]).length() > 65 )
            errors.addElement("location field may not be longer than 65 characters");

        String site = (String)newLoc.get("site");
        if( site == null ) site = "";
        values[SITE_INDEX] = site.trim();
        if( site.trim().length() > 16 )
            errors.addElement("site field may not be longer than 16 characters");

        String code = (String)newLoc.get("code");
        if( code == null ) code = "";
        values[CODE_INDEX] = code.trim();
        if( code.trim().length() > 16 )
            errors.addElement("code field may not be longer than 16 characters");

        if( errors.size() > 0 )
            throw new NetDBException("", errors);
    }
}
