/************************************************************************
 *
 * MXDeleteCommand.java - db call NetDB_MXrecord.del
 *
 * $Id: MXDeleteCommand.java,v 1.1.1.1 2006/06/30 23:38:09 priimak Exp $
 *
 *-----------------------------------------------------------------------
 * Copyright (c) 2003, Board of Trustees, Leland Stanford Jr. University
 ************************************************************************/
package stanford.netdb.lib;

import stanford.netdb.utils.*;
import java.lang.*;
import java.sql.*;

/** db call NetDB_MXrecord.del */
class MXDeleteCommand extends DBCall {

    public static final int ID_OP_USER_INDEX     = 0; // p_op_uid
    public static final int LOCK_INDEX           = 1; // p_lock
    public static final int MX_NAME_ID_INDEX     = 2; // p_sent_to_id
    public static final int MX_NAME_INDEX        = 3; // p_sent_to
    public static final int PARENT_NAME_ID_INDEX = 4; // p_received_by_id
    public static final int PARENT_NAME_INDEX    = 5; // p_received_by

    public MXDeleteCommand(stanford.netdb.utils.Logger logger, String mxFQDN,
                           String parentFQDN, Timestamp lock, Integer op_uid) {
        super(logger);
        db_call_type = ORA_PROC_CALL;
        values = new Object[6];

        values[ID_OP_USER_INDEX]     = op_uid;
        values[LOCK_INDEX]           = lock;
        values[MX_NAME_ID_INDEX]     = new Null(Types.NUMERIC);
        values[MX_NAME_INDEX]        = mxFQDN;
        values[PARENT_NAME_ID_INDEX] = new Null(Types.NUMERIC);
        values[PARENT_NAME_INDEX]    = parentFQDN;
    }

    public String getSQL() {
        return proc_call_sql("NetDB_MXrecord.del");
    }
}
