/************************************************************************
 *
 * MakeCommand.java - provides all constats for NetDB_Make.master call.
 *
 * $Id: MakeCommand.java,v 1.1.1.1 2006/06/30 23:38:09 priimak Exp $
 *
 *-----------------------------------------------------------------------
 * Copyright (c) 2001 Board of Trustees, Leland Stanford Jr. University
 ************************************************************************/
package stanford.netdb.lib;

import stanford.netdb.utils.*;
import java.lang.*;
import java.sql.*;

/** contains all constants for NetDB_Make procedure call */
abstract class MakeCommand extends DBCall {
    public static final int ACTION_INDEX                = 1;  // p_action
    public static final int OP_USER_INDEX               = 2;  // p_op_uid
    public static final int MAKE_INDEX                  = 3;  // p_make
    public static final int NEW_MAKE_INDEX              = 4;  // p_make_new

    public MakeCommand(stanford.netdb.utils.Logger logger) {
        super(logger);
        values = new Object[5];
        values[0]                       = ref_cursor;
        values[ACTION_INDEX]            = new Null(Types.VARCHAR);
        values[OP_USER_INDEX]           = new Null(Types.NUMERIC);
        values[MAKE_INDEX]              = new Null(Types.VARCHAR);
        values[NEW_MAKE_INDEX]          = new Null(Types.VARCHAR);
    }

    public String getSQL() {
        return proc_call_sql("NetDB_Make.master");
    }
}
