/************************************************************************
 *
 * ModelCommand.java - provides all constats NetDB_Model.master call.
 *
 * $Id: ModelCommand.java,v 1.1.1.1 2006/06/30 23:38:09 priimak Exp $
 *
 *-----------------------------------------------------------------------
 * Copyright (c) 2001 Board of Trustees, Leland Stanford Jr. University
 ************************************************************************/
package stanford.netdb.lib;

import stanford.netdb.utils.*;
import java.lang.*;
import java.sql.*;

/** contains all constants for NetDB_Model.master procedure call */
abstract class ModelCommand extends DBCall {

    public static final int ACTION_INDEX         = 1; // p_action
    public static final int ID_OP_USER_INDEX     = 2; // p_op_uid
    public static final int MODEL_ID_INDEX       = 3; // p_model_id
    public static final int MAKE_INDEX           = 4; // p_make
    public static final int MODEL_NAME_INDEX     = 5; // p_modelname
    public static final int MAKE_NEW_INDEX       = 6; // p_make_new
    public static final int MODEL_NAME_NEW_INDEX = 7; // p_modelname_new
    public static final int MODEL_TYPE_INDEX     = 8; // p_type

    public ModelCommand(stanford.netdb.utils.Logger logger) {
        super(logger);
        values = new Object[9];
        db_call_type = ORA_FUN_IGNORE_RET_CALL;

        values[0]                    = ref_cursor;
        values[ACTION_INDEX]         = new Null(Types.VARCHAR);
        values[ID_OP_USER_INDEX]     = new Null(Types.NUMERIC);
        values[MODEL_ID_INDEX]       = new Null(Types.NUMERIC);
        values[MAKE_INDEX]           = new Null(Types.VARCHAR);
        values[MODEL_NAME_INDEX]     = new Null(Types.VARCHAR);
        values[MAKE_NEW_INDEX]       = new Null(Types.VARCHAR);
        values[MODEL_NAME_NEW_INDEX] = new Null(Types.VARCHAR);
        values[MODEL_TYPE_INDEX]     = new Null(Types.VARCHAR);
    }

    public String getSQL() {
        return proc_call_sql("NetDB_Model.master");
    }
}
