/************************************************************************
 *
 * ModelModifyCommand.java - db call NetDB_Model.master 'update'
 *
 * $Id: ModelModifyCommand.java,v 1.1.1.1 2006/06/30 23:38:09 priimak Exp $
 *
 *-----------------------------------------------------------------------
 * Copyright (c) 2002, Board of Trustees, Leland Stanford Jr. University
 ************************************************************************/
package stanford.netdb.lib;

import stanford.netdb.utils.*;
import java.util.*;
import java.lang.*;

/** db call NetDB_Model.master 'update' */
class ModelModifyCommand extends ModelCommand {

    public ModelModifyCommand(stanford.netdb.utils.Logger logger,
                              Hashtable oldModel, Hashtable newModel,
                              Integer op_uid)
    {
        super(logger);
        values[ACTION_INDEX]         = "update";
        values[ID_OP_USER_INDEX]     = op_uid;
        values[MODEL_ID_INDEX]       = new Integer((String)oldModel.get("id"));
        values[MAKE_NEW_INDEX]       = newModel.get("make");
        values[MODEL_NAME_NEW_INDEX] = newModel.get("model");

        String type = ((String)Utils.n2s(newModel.get("type"))).trim();
        if( type.length() > 0 ) values[MODEL_TYPE_INDEX] = type;

        String oldID = (String)oldModel.get("id");
        String newID = (String)newModel.get("id");
        if (!oldID.equals (newID))
            values[ACTION_INDEX] = "replace";
    }
}
