/************************************************************************
 *
 * NameReserveCommand.java - db call NetDB_Name.reserve
 *
 * $Id: NameReserveCommand.java,v 1.1.1.1 2006/06/30 23:38:09 priimak Exp $
 *
 *-----------------------------------------------------------------------
 * Copyright (c) 2002, Board of Trustees, Leland Stanford Jr. University
 ************************************************************************/
package stanford.netdb.lib;

import java.lang.*;
import java.sql.*;

/** db call NetDB_Name.reserve */
class NameReserveCommand extends DBCall {

    public static final int ID_OP_USER_INDEX = 1; // p_op_uid
    public static final int NAME_INDEX       = 2; // p_name
    public static final int DOMAIN_INDEX     = 3; // p_domain
    public static final int TYPE_INDEX       = 4; // p_type

    /**
     * type = Constants.{DOMAIN_TYPE, NODE_NAME_TYPE, ADDRESS_NAME_TYPE, INTERFACE_NAME_TYPE,
     *                   NETWORK_NAME_TYPE, NAME_ALIAS_TYPE, MX_TYPE}
     **/
    public NameReserveCommand(stanford.netdb.utils.Logger logger, String name,
                              String domain, String type, Integer op_uid) {
        super(logger);
        values = new Object[5];

        values[0]                = ref_cursor;
        values[ID_OP_USER_INDEX] = op_uid;
        values[NAME_INDEX]       = name;
        values[DOMAIN_INDEX]     = domain;
        values[TYPE_INDEX]       = type;
    }

    public String getSQL() {
        return proc_call_sql("NetDB_Name.reserve");
    }
}
