/************************************************************************
 *
 * NetworkLocationCommand.java -
 *
 * $Id: NetworkLocationCommand.java,v 1.1 2006/09/14 17:38:56 priimak Exp $
 *
 *-----------------------------------------------------------------------
 * Copyright (c) 2006, Board of Trustees, Leland Stanford Jr. University
 ************************************************************************/
package stanford.netdb.lib;

import stanford.netdb.utils.*;
import java.lang.*;
import java.sql.*;

/** db call NetDB_Network.location */
class NetworkLocationCommand extends DBCall {

    public static String DELETE_ACTION = "remove";
    public static String INSERT_ACTION = "add";

    public static final int ACTION_INDEX      = 0; // p_action
    public static final int ID_OP_USER_INDEX  = 1; // p_op_uid
    public static final int LOCK_INDEX        = 2; // p_lock
    public static final int NETWORK_ID_INDEX  = 3; // p_network_id
    public static final int LOCATION_ID_INDEX = 4; // location

    public NetworkLocationCommand(stanford.netdb.utils.Logger logger, String action,
                                  Integer network_id, Timestamp lock, String location,
                                  Integer op_uid)
    {
        super(logger);
        values = new Object[5];
        db_call_type = ORA_PROC_CALL;

        values[ACTION_INDEX]      = action;
        values[ID_OP_USER_INDEX]  = op_uid;
        values[LOCK_INDEX]        = lock;
        values[NETWORK_ID_INDEX]  = network_id;
        values[LOCATION_ID_INDEX] = location;
    }

    public String getSQL() {
        String dbschema = System.getProperty(Constants.DBSCHEMA_KEY);
        return "{call "+dbschema+".NetDB_Network.location(?, ?, ?, ?, "+
            dbschema+".NetDB_Location.verify_or_die(null, ?))}";
    }
}
