/************************************************************************
 *
 * NetworkLockUnLockCommand.java - db call NetDB_Network.master 'lock/unlock'
 *
 * $Id: NetworkLockUnLockCommand.java,v 1.1.1.1 2006/06/30 23:38:09 priimak Exp $
 *
 *-----------------------------------------------------------------------
 * Copyright (c) 2002, Board of Trustees, Leland Stanford Jr. University
 ************************************************************************/
package stanford.netdb.lib;

import java.lang.*;
import java.sql.*;

/** db call NetDB_Network.master 'lock/unlock' */
class NetworkLockUnLockCommand extends NetworkCommand {

    public static final String LOCK_ACTION   = "lock";
    public static final String UNLOCK_ACTION = "unlock";

    public NetworkLockUnLockCommand(stanford.netdb.utils.Logger logger,
                                    String action,
                                    String netHandle,
                                    int id,
                                    Timestamp tm,
                                    Integer op_uid) {
        super(logger);
        if( action.equals(UNLOCK_ACTION) )
            db_call_type = ORA_FUN_IGNORE_RET_CALL;

        values[ACTION_INDEX] = action;

        if( netHandle == null )
            values[ID_NETWORK_INDEX] = new Integer(id);
        else
            values[NETWORK_INDEX]    = netHandle;

        values[ID_OP_USER_INDEX] = op_uid;
        values[LOCKED_INDEX]     = o2n(tm, Types.TIMESTAMP);
    }
}
