/************************************************************************
 *
 * NodeAdminCommand.java - db call NetDB_Node.admin
 *
 * $Id: NodeAdminCommand.java,v 1.1.1.1 2006/06/30 23:38:09 priimak Exp $
 *
 *-----------------------------------------------------------------------
 * Copyright (c) 2002, Board of Trustees, Leland Stanford Jr. University
 ************************************************************************/
package stanford.netdb.lib;

import stanford.netdb.utils.*;
import java.lang.*;
import java.sql.*;

class NodeAdminCommand extends DBCall {

    public static final String INSERT_ACTION   = "add";
    public static final String DELETE_ACTION   = "remove";

    public static final int ACTION_INDEX       = 0;  // p_action
    public static final int ID_OP_USER_INDEX   = 1;  // p_op_uid
    public static final int LOCK_INDEX         = 2;  // p_lock
    public static final int ID_NODE_INDEX      = 3;  // p_node_id
    public static final int NODE_NAME_INDEX    = 4;  // p_node
    public static final int ATEAM_ID_INDEX     = 5;  // p_ateam_id
    public static final int ATEAM_NAME_INDEX   = 6;  // p_ateam
    public static final int PERSON_ID_INDEX    = 7;  // p_person_id
    public static final int PERSON_REGID_INDEX = 8;  // p_regid

    public NodeAdminCommand(stanford.netdb.utils.Logger logger, String action, Timestamp lock,
                            Integer idNode, String ateamName, Integer person_id, Integer op_uid)
    {
        super(logger);
        values = new Object[9];
        db_call_type = ORA_PROC_CALL;

        values[ACTION_INDEX]       = action;
        values[ID_OP_USER_INDEX]   = op_uid;
        values[LOCK_INDEX]         = lock;
        values[ID_NODE_INDEX]      = idNode;
        values[NODE_NAME_INDEX]    = new Null(Types.VARCHAR);
        values[ATEAM_ID_INDEX]     = new Null(Types.NUMERIC);
        values[ATEAM_NAME_INDEX]   = o2v(ateamName);
        values[PERSON_ID_INDEX]    = o2n(person_id, Types.NUMERIC);
        values[PERSON_REGID_INDEX] = new Null(Types.VARCHAR);
    }

    public String getSQL() {
        return proc_call_sql("NetDB_Node.admin");
    }
}
