/************************************************************************
 *
 * NodeLockUnLockCommand.java -
 *
 * $Id: NodeLockUnLockCommand.java,v 1.1.1.1 2006/06/30 23:38:09 priimak Exp $
 *
 *-----------------------------------------------------------------------
 * Copyright (c) 2002, Board of Trustees, Leland Stanford Jr. University
 ************************************************************************/
package stanford.netdb.lib;

import java.lang.*;
import java.sql.*;

/** db call pNetwork 'lock/unlock' */
class NodeLockUnLockCommand extends NodeCommand {

    public static final String LOCK_ACTION   = "lock";
    public static final String UNLOCK_ACTION = "unlock";

    public NodeLockUnLockCommand(stanford.netdb.utils.Logger logger,
                                 String action,
                                 String nodeHandle,
                                 int id,
                                 Timestamp tm,
                                 Integer op_uid) {
        super(logger);
        if( action.equals(UNLOCK_ACTION) )
            db_call_type = ORA_FUN_IGNORE_RET_CALL;

        values[ACTION_INDEX] = action;

        if( nodeHandle == null )
            values[ID_NODE_INDEX] = new Integer(id);
        else
            values[NAME_INDEX] = nodeHandle;

        values[OP_USER_INDEX] = op_uid;
        values[LOCKED_INDEX]  = o2n(tm, Types.TIMESTAMP);
    }
}
