/************************************************************************
 *
 * NodeOSCommand.java - db call NetDB_Node.OS
 *
 * $Id: NodeOSCommand.java,v 1.1.1.1 2006/06/30 23:38:09 priimak Exp $
 *
 *-----------------------------------------------------------------------
 * Copyright (c) 2002, Board of Trustees, Leland Stanford Jr. University
 ************************************************************************/
package stanford.netdb.lib;

import stanford.netdb.utils.*;
import java.lang.*;
import java.sql.*;

/** db call NetDB_Node.OS */
class NodeOSCommand extends DBCall {

    public static String DELETE_ACTION = "remove";
    public static String INSERT_ACTION = "add";

    public static final int ACTION_INDEX     = 0; // p_action
    public static final int ID_OP_USER_INDEX = 1; // p_op_uid
    public static final int LOCK_INDEX       = 2; // p_lock
    public static final int NODE_ID_INDEX    = 3; // p_node_id
    public static final int NODE_NAME_INDEX  = 4; // p_node
    public static final int OS_NAME_INDEX    = 5; // p_os
    public static final int OS_VERSION_INDEX = 6; // p_version

    public NodeOSCommand(stanford.netdb.utils.Logger logger, String action,
                         Integer nodeID, Timestamp lock, String os, Integer op_uid)
    {
        super(logger);
        values = new Object[7];
        db_call_type = ORA_PROC_CALL;

        values[ACTION_INDEX]     = action;
        values[ID_OP_USER_INDEX] = op_uid;
        values[LOCK_INDEX]       = lock;
        values[NODE_ID_INDEX]    = nodeID;
        values[NODE_NAME_INDEX]  = new Null(Types.VARCHAR);
        values[OS_NAME_INDEX]    = os;
        values[OS_VERSION_INDEX] = "";
    }

    public String getSQL() {
        return proc_call_sql("NetDB_Node.OS");
    }
}
