/************************************************************************
 *
 * NodeTypeListCommand.java - NetDB_NodeTpe.list procedure call
 *
 * $Id: NodeTypeListCommand.java,v 1.1 2006/10/03 23:30:47 priimak Exp $
 *
 *-----------------------------------------------------------------------
 * Copyright (c) 2006, Board of Trustees, Leland Stanford Jr. University
 ************************************************************************/
package stanford.netdb.lib;

import stanford.netdb.utils.*;
import java.lang.*;
import java.sql.*;

/** contains all constants for NetDB_NodeTpe.list procedure call */
public class NodeTypeListCommand extends DBCall {

    public static final int UID_INDEX = 1; // p_user_id

    public NodeTypeListCommand(stanford.netdb.utils.Logger logger, Integer uid) {
        super(logger);

        values            = new Object[2];
        values[0]         = ref_cursor;
        values[UID_INDEX] = o2n(uid, Types.NUMERIC);
    }

    public String getSQL() {
        return proc_call_sql("NetDB_NodeType.list");
    }
} // end of class NodeTypeListCommand
