/************************************************************************
 *
 * OSCommand.java - contains all constants for NetDB_OS.master procedure call
 *
 * $Id: OSCommand.java,v 1.1.1.1 2006/06/30 23:38:09 priimak Exp $
 *
 *-----------------------------------------------------------------------
 * Copyright (c) 2001 Board of Trustees, Leland Stanford Jr. University
 ************************************************************************/
package stanford.netdb.lib;

import stanford.netdb.utils.*;
import java.lang.*;
import java.sql.*;

/** contains all constants for NetDB_OS.master procedure call */
abstract class OSCommand extends DBCall {

    public static final int ACTION_INDEX                = 1; // p_action
    public static final int OP_USER_INDEX               = 2; // p_op_uid
    public static final int OS_NAME_INDEX               = 3; // p_os
    public static final int OS_NEW_NAME_INDEX           = 4; // p_os_new
    public static final int DESCRIPTION_INDEX           = 5; // p_description

    public OSCommand(stanford.netdb.utils.Logger logger) {
        super(logger);
        values = new Object[6];
        values[0]                       = ref_cursor;
        values[ACTION_INDEX]            = new Null(Types.VARCHAR);
        values[OP_USER_INDEX]           = new Null(Types.NUMERIC);
        values[OS_NAME_INDEX]           = new Null(Types.VARCHAR);
        values[OS_NEW_NAME_INDEX]       = new Null(Types.VARCHAR);
        values[DESCRIPTION_INDEX]       = new Null(Types.VARCHAR);
    }

    public String getSQL() {
        return proc_call_sql("NetDB_OS.master");
    }
}
