/************************************************************************
 *
 * OSDeleteCommand.java - db call NetDB_OS.master 'delete'
 *
 * $Id: OSDeleteCommand.java,v 1.1.1.1 2006/06/30 23:38:09 priimak Exp $
 *
 *-----------------------------------------------------------------------
 * Copyright (c) 2002, Board of Trustees, Leland Stanford Jr. University
 ************************************************************************/
package stanford.netdb.lib;

import java.lang.*;
import java.util.*;

/** db call NetDB_OS.master 'delete' */
class OSDeleteCommand extends OSCommand {

    /**
     * Constructor for OSDeleteCommand class.
     *
     * @param os         OS object we want to delete
     * @param regID      regID of operating user
     */
    public OSDeleteCommand(stanford.netdb.utils.Logger logger, Hashtable os,
                           Integer op_uid)
    {
        super(logger);
        db_call_type = ORA_FUN_IGNORE_RET_CALL;

        values[ACTION_INDEX]  = "delete";
        values[OP_USER_INDEX] = op_uid;
        values[OS_NAME_INDEX] = os.get("name");
    }
}
