/************************************************************************
 *
 * OutParam.java -
 *
 * $Id: OutParam.java,v 1.1.1.1 2006/06/30 23:38:09 priimak Exp $
 *
 *-----------------------------------------------------------------------
 * Copyright (c) 2001 Board of Trustees, Leland Stanford Jr. University
 ************************************************************************/
package stanford.netdb.lib;

import java.lang.*;
import java.sql.*;
import oracle.jdbc.driver.*;

class OutParam extends Object {

    private int type;

    /** Constructor for Null of type = java.sql.Types.* */
    public OutParam(int type) {
        this.type = type;
    }

    /** Returns type of this Null */
    public int getType() {
        return type;
    }

    /** Pretty print for the object. It is useful for debugging */
    public String toString() {
        String result = "OutParam(";
        switch( type ) {
        case OracleTypes.NUMERIC:     return result + "NUMERIC)";
        case OracleTypes.TINYINT:     return result + "TINYINT)";
        case OracleTypes.VARCHAR:     return result + "VARCHAR)";
        case OracleTypes.TIMESTAMP:   return result + "TIMESTAMP)";
        case OracleTypes.BIT:         return result + "BIT)";
        case OracleTypes.CURSOR:      return result + "CURSOR)";
        default:
            return result + "?)";
        }
    }
}
