/************************************************************************
 *
 * PersonCommand.java - db call NetDB_Person.master
 *
 * $Id: PersonCommand.java,v 1.1.1.1 2006/06/30 23:38:09 priimak Exp $
 *
 *-----------------------------------------------------------------------
 * Copyright (c) 2002, Board of Trustees, Leland Stanford Jr. University
 ************************************************************************/
package stanford.netdb.lib;

import stanford.netdb.utils.*;
import java.lang.*;
import java.sql.*;

abstract class PersonCommand extends DBCall {

    public static final int ACTION_INDEX          = 1;  // p_action
    public static final int ID_OP_USER_INDEX      = 2;  // p_op_uid
    public static final int PERSON_ID_INDEX       = 3;  // p_person_id
    public static final int REG_ID_PERSON_INDEX   = 4;  // p_person_regid
    public static final int NAME_INDEX            = 5;  // p_name
    public static final int NET_ID_INDEX          = 6;  // p_netid
    public static final int EMAIL_INDEX           = 7;  // p_email
    public static final int PHONE_INDEX           = 8;  // p_phone
    public static final int ACTIVE_INDEX          = 9;  // p_active
    public static final int LOWER_LAST_NAME_INDEX = 10; // p_lastname
    public static final int DIR_ID_INDEX          = 11; // p_rirectoryid

    public PersonCommand(stanford.netdb.utils.Logger logger) {
        super(logger);

        values = new Object[12];
        values[0]                     = ref_cursor;
        values[ACTION_INDEX]          = new Null(Types.VARCHAR);
        values[ID_OP_USER_INDEX]      = new Null(Types.NUMERIC);
        values[PERSON_ID_INDEX]       = new Null(Types.NUMERIC);
        values[REG_ID_PERSON_INDEX]   = new Null(Types.VARCHAR);
        values[NAME_INDEX]            = new Null(Types.VARCHAR);
        values[NET_ID_INDEX]          = new Null(Types.VARCHAR);
        values[EMAIL_INDEX]           = new Null(Types.VARCHAR);
        values[PHONE_INDEX]           = new Null(Types.VARCHAR);
        values[ACTIVE_INDEX]          = new Null(Types.TINYINT);
        values[LOWER_LAST_NAME_INDEX] = new Null(Types.VARCHAR);
        values[DIR_ID_INDEX]          = new Null(Types.VARCHAR);
    }

    public String getSQL() {
        return proc_call_sql("NetDB_Person.master");
    }
}
