/************************************************************************
 *
 * PersonInsertUpdateCommand.java - db call NetDB_Person.master 'insert'
 *
 * $Id: PersonInsertUpdateCommand.java,v 1.1.1.1 2006/06/30 23:38:09 priimak Exp $
 *
 *-----------------------------------------------------------------------
 * Copyright (c) 2002, Board of Trustees, Leland Stanford Jr. University
 ************************************************************************/
package stanford.netdb.lib;

import java.lang.*;
import java.util.*;

/** db call NetDB_Person.master 'insert' */
class PersonInsertUpdateCommand extends PersonCommand {

    public PersonInsertUpdateCommand(stanford.netdb.utils.Logger logger, Hashtable person, Integer op_uid) {
        super(logger);

        values[ACTION_INDEX]        = "insert"; // also does update
        values[ID_OP_USER_INDEX]    = op_uid;
        values[REG_ID_PERSON_INDEX] = person.get("RegID"); // person *must* have RegID

        if( person.get("name") != null )
            values[NAME_INDEX] = ((String)person.get("name")).trim();

        if( person.get("NetID") != null )
            values[NET_ID_INDEX] = ((String)person.get("NetID")).trim();

        if( person.get("email") != null )
            values[EMAIL_INDEX] = ((String)person.get("email")).trim();

        if( person.get("phone") != null )
            values[PHONE_INDEX] = ((String)person.get("phone")).trim();

        if( person.get("active?") == null )
            values[ACTIVE_INDEX] = new Short((short)0); // presume inactive
        else
            values[ACTIVE_INDEX] = new Short( ((Boolean)person.get("active?")).booleanValue()?(short)1:(short)0 );

        if( person.get("DirID") != null )
            values[DIR_ID_INDEX] = ((String)person.get("DirID")).trim();

        if( person.get("lastname") != null )
            values[LOWER_LAST_NAME_INDEX] = ((String)person.get("lastname")).trim().toLowerCase();
    }
}
