/************************************************************************
 *
 * SimpleSearchCommand.java - base class for all simple searches, it is
 *                            abstract becouse it doesn't implement getSQL
 *
 * $Id: SimpleSearchCommand.java,v 1.1.1.1 2006/06/30 23:38:09 priimak Exp $
 *
 *-----------------------------------------------------------------------
 * Copyright (c) 2001 Board of Trustees, Leland Stanford Jr. University
 ************************************************************************/
package stanford.netdb.lib;

import java.util.*;
import java.lang.*;

/**
 * base class for all simple searches, it is abstract becouse
 * it doesn't implement getSQL
 */
abstract class SimpleSearchCommand extends DBCall {

    public static final int SEARCH_VALUE_LOW_INDEX      = 1;
    public static final int SEARCH_VALUE_HIGH_INDEX     = 2;
    public static final int SEARCH_FOR_INDEX            = 3;
    public static final int OP_USER_ID_INDEX            = 4;

    public SimpleSearchCommand(stanford.netdb.utils.Logger logger) {
        super(logger);
        values = new Object[4];
    }

    /**
     * normally we don't have access to protected variable 'DBVCall.values',
     * but we do need it now.
     */
    public void setParam(int index, Object val) {
        values[index] = val;
    }

    /** reset error result set index to -1 */
    public int errorResultSetIndex() {
        return -1;
    }

    /** */
    public static Hashtable getChild(Hashtable parent, String key) {
        Hashtable child = (Hashtable)parent.get(key);
        if( child == null ) {
            child = new Hashtable();
            parent.put(key, child);
        }
        return child;
    }
}
