/************************************************************************
 *
 * StateCommand.java - base class for db call NetDB_State.master
 *
 *
 *
 *-----------------------------------------------------------------------
 * Copyright (c) 2005 Board of Trustees, Leland Stanford Jr. University
 ************************************************************************/
package stanford.netdb.lib;

import stanford.netdb.utils.*;
import java.lang.*;
import java.sql.*;

/** base class for db call NetDB_State.master */
abstract class StateCommand extends DBCall {

    public static final int ACTION_INDEX         = 1;  // p_action
    public static final int ID_OP_USER_INDEX     = 2;  // p_op_uid
    public static final int STATE_NAME_INDEX     = 3;  // p_state
    public static final int STATE_NEW_NAME_INDEX = 4;  // p_state_new
    public static final int STATE_RANK_INDEX     = 5;  // p_rank
    public static final int DENY_DHCP_INDEX      = 6;  // p_denyDHCP
    public static final int DENY_DNS_INDEX       = 7;  // p_denyDNS
    public static final int DESCRIPTION_INDEX    = 8;  // p_description
    public static final int ACCESS_GROUP_INDEX   = 9;  // p_accessgroup

    public StateCommand(stanford.netdb.utils.Logger logger) {
        super(logger);
        values = new Object[10];
        values[0]                    = ref_cursor;
        values[ACTION_INDEX]         = new Null(Types.VARCHAR);
        values[ID_OP_USER_INDEX]     = new Null(Types.NUMERIC);
        values[STATE_NAME_INDEX]     = new Null(Types.VARCHAR);
        values[STATE_NEW_NAME_INDEX] = new Null(Types.VARCHAR);
        values[STATE_RANK_INDEX]     = new Null(Types.NUMERIC);
        values[DENY_DHCP_INDEX]      = new Null(Types.NUMERIC);
        values[DENY_DNS_INDEX]       = new Null(Types.NUMERIC);
        values[DESCRIPTION_INDEX]    = new Null(Types.VARCHAR);
        values[ACCESS_GROUP_INDEX]   = new Null(Types.VARCHAR);
    }

    public String getSQL() {
        return proc_call_sql("NetDB_State.master");
    }
}
