/************************************************************************
 *
 * StateDeleteCommand.java - db call NetDB_State.master 'delete'
 *
 *
 *
 *-----------------------------------------------------------------------
 * Copyright (c) 2005, Board of Trustees, Leland Stanford Jr. University
 ************************************************************************/
package stanford.netdb.lib;

import java.lang.*;
import java.util.*;

/** db call NetDB_State.master 'delete' */
class StateDeleteCommand extends StateCommand {

    /**
     * Constructor for StateDeleteCommand class.
     *
     * @param state      state object to be deleted from db
     * @param op_uid     id of operating user
     */
    public StateDeleteCommand(stanford.netdb.utils.Logger logger,
                              Hashtable state, Integer op_uid) {
        super(logger);

        db_call_type = ORA_FUN_IGNORE_RET_CALL;

        values[ACTION_INDEX]     = "delete";
        values[ID_OP_USER_INDEX] = op_uid;
        values[STATE_NAME_INDEX] = state.get("name");
    }
}
