/************************************************************************
 *
 * StateInsertCommand.java - db call NetDB_State.master 'insert'
 *
 *
 *
 *-----------------------------------------------------------------------
 * Copyright (c) 2005, Board of Trustees, Leland Stanford Jr. University
 ************************************************************************/
package stanford.netdb.lib;

import java.lang.*;
import java.util.*;

/** db call NetDB_State.master 'insert' */
class StateInsertCommand extends StateCommand {

    /**
     * Constructor for StateInsertCommand class.
     *
     * @param newState   state object to be inserted into db
     * @param op_uid     id of operating user
     */
    public StateInsertCommand(stanford.netdb.utils.Logger logger,
                              Hashtable newState, Integer op_uid) {
        super(logger);

        db_call_type = ORA_FUN_IGNORE_RET_CALL;

        values[ACTION_INDEX]            = "insert";
        values[ID_OP_USER_INDEX]        = op_uid;
        values[STATE_NAME_INDEX]        = newState.get("name");

        if( newState.get("rank") != null )
            values[STATE_RANK_INDEX]    = newState.get("rank");

        if( newState.get("denyDHCP") != null )
            values[DENY_DHCP_INDEX]     = new Short( ((Boolean)newState.get("denyDHCP")).booleanValue()?"1":"0" );

        if( newState.get("denyDNS") != null )
            values[DENY_DNS_INDEX]      = new Short( ((Boolean)newState.get("denyDNS")).booleanValue()?"1":"0" );

        if((newState.get("description")!=null) &&
          ((String)newState.get("description")).trim().length() > 0 )
            values[DESCRIPTION_INDEX]   = newState.get("description");

        if((newState.get("access")!=null) &&
          ((String)newState.get("access")).trim().length() > 0 )
            values[ACCESS_GROUP_INDEX]  = o2v(newState.get("access"));
    }
}
