/************************************************************************
 *
 * UserCommand.java - provides all constats for NetDB_User.master call.
 *
 * $Id: UserCommand.java,v 1.1.1.1 2006/06/30 23:38:10 priimak Exp $
 *
 *-----------------------------------------------------------------------
 * Copyright (c) 2001 Board of Trustees, Leland Stanford Jr. University
 ************************************************************************/
package stanford.netdb.lib;

import stanford.netdb.utils.*;
import java.lang.*;
import java.sql.*;

/** contains all constants for pUser procedure call */
abstract class UserCommand extends DBCall {

    protected Timestamp lock;

    public static final int ACTION_INDEX         = 1;  // p_action
    public static final int OP_USER_INDEX        = 2;  // p_op_uid
    public static final int LOCKED_INDEX         = 3;  // p_lock
    public static final int ID_INDEX             = 4;  // p_user_id
    public static final int NET_ID_INDEX         = 5;  // p_netid
    public static final int PERSON_ID_INDEX      = 6;  // p_person_id
    public static final int DEF_GROUP_INDEX      = 7;  // p_def_group
    public static final int DEF_DOMAIN_INDEX     = 8;  // p_def_domain
    public static final int DEF_ADDR_SPACE_INDEX = 9;  // p_def_prefix
    public static final int ACTIVE_INDEX         = 10; // p_active
    public static final int ALL_OBJ_INDEX        = 11; // p_all_records
    public static final int ALL_GROUPS_INDEX     = 12; // p_all_groups
    public static final int COMMENT_INDEX        = 13; // p_comment

    public UserCommand(stanford.netdb.utils.Logger logger) {
        super(logger);
        db_call_type = ORA_FUN_IGNORE_RET_CALL;

        values = new Object[14];
        values[0]                    = ref_cursor;
        values[ACTION_INDEX]         = new Null(Types.VARCHAR);
        values[OP_USER_INDEX]        = new Null(Types.NUMERIC);
        values[LOCKED_INDEX]         = new Null(Types.TIMESTAMP);
        values[ID_INDEX]             = new Null(Types.NUMERIC);
        values[NET_ID_INDEX]         = new Null(Types.VARCHAR);
        values[PERSON_ID_INDEX]      = new Null(Types.NUMERIC);
        values[DEF_GROUP_INDEX]      = new Null(Types.VARCHAR);
        values[DEF_DOMAIN_INDEX]     = new Null(Types.VARCHAR);
        values[DEF_ADDR_SPACE_INDEX] = new Null(Types.VARCHAR);
        values[ACTIVE_INDEX]         = new Null(Types.TINYINT);
        values[ALL_OBJ_INDEX]        = new Null(Types.TINYINT);
        values[ALL_GROUPS_INDEX]     = new Null(Types.TINYINT);
        values[COMMENT_INDEX]        = new Null(Types.VARCHAR);
    }

    public String getSQL() {
        return proc_call_sql("NetDB_User.master");
    }
}
