/************************************************************************
 *
 * UserDeleteCommand.java - db call pUser 'delete'
 *
 * $Id: UserDeleteCommand.java,v 1.1.1.1 2006/06/30 23:38:10 priimak Exp $
 *
 *-----------------------------------------------------------------------
 * Copyright (c) 2002, Board of Trustees, Leland Stanford Jr. University
 ************************************************************************/
package stanford.netdb.lib;

import stanford.netdb.utils.*;
import java.lang.*;
import java.sql.*;

/** db call pUser 'delete' */
class UserDeleteCommand extends UserCommand {

    public UserDeleteCommand(stanford.netdb.utils.Logger logger, String netID,
                             Integer idUser, Timestamp lockTm, Integer op_uid)
    {
        super(logger);
        values[ACTION_INDEX]            = "delete";
        if( netID == null )
            values[NET_ID_INDEX] = new Null(Types.VARCHAR);
        else
            values[NET_ID_INDEX] = netID;
        if( idUser == null )
            values[ID_INDEX] = new Null(Types.NUMERIC);
        else
            values[ID_INDEX] = idUser;
        values[OP_USER_INDEX] = op_uid;
        values[LOCKED_INDEX] = lockTm;
    }
}
