/************************************************************************
 *
 * UserDepartmentCommand.java - db call NetDB_User.org
 *
 * $Id: UserDepartmentCommand.java,v 1.1.1.1 2006/06/30 23:38:10 priimak Exp $
 *
 *-----------------------------------------------------------------------
 * Copyright (c) 2002, Board of Trustees, Leland Stanford Jr. University
 ************************************************************************/
package stanford.netdb.lib;

import stanford.netdb.utils.*;
import java.lang.*;
import java.sql.*;

/** db call NetDB_User.org */
class UserDepartmentCommand extends DBCall {

    public static final String INSERT_ACTION = "insert";
    public static final String UPDATE_ACTION = "update";
    public static final String DELETE_ACTION = "delete";

    public static final int ACTION_INDEX     = 0;  // p_action
    public static final int ID_OP_USER_INDEX = 1;  // p_op_uid
    public static final int LOCK_INDEX       = 2;  // p_lock
    public static final int USER_ID_INDEX    = 3;  // p_user_id
    public static final int ORG_ID_INDEX     = 4;  // p_org_id
    public static final int ORG_NAME_INDEX   = 5;  // p_org_name
    public static final int OFFICIAL_INDEX   = 6;  // p_official

    public UserDepartmentCommand(stanford.netdb.utils.Logger logger, String action,
                                 Integer user_id, String org, boolean official,
                                 Timestamp lock, Integer op_uid) {
        super(logger);
        db_call_type = ORA_PROC_CALL;

        values = new Object[7];
        values[ACTION_INDEX]     = action;
        values[ID_OP_USER_INDEX] = op_uid;
        values[LOCK_INDEX]       = lock;
        values[USER_ID_INDEX]    = user_id;
        values[ORG_ID_INDEX]     = new Null(Types.NUMERIC);
        values[ORG_NAME_INDEX]   = org;
        values[OFFICIAL_INDEX]   = new Short(official?(short)1:(short)0);
    }

    public String getSQL() {
        return proc_call_sql("NetDB_User.org");
    }
}
