/************************************************************************
 *
 * UserLockUnLockCommand.java - db call NetDB_User.master 'lock/unlock'
 *
 * $Id: UserLockUnLockCommand.java,v 1.1.1.1 2006/06/30 23:38:10 priimak Exp $
 *
 *-----------------------------------------------------------------------
 * Copyright (c) 2002, Board of Trustees, Leland Stanford Jr. University
 ************************************************************************/
package stanford.netdb.lib;

import java.lang.*;
import java.sql.*;

/** db call NetDB_User.master 'lock/unlock' */
class UserLockUnLockCommand extends UserCommand {

    public static final String LOCK_ACTION   = "lock";
    public static final String UNLOCK_ACTION = "unlock";

    public UserLockUnLockCommand(stanford.netdb.utils.Logger logger, String action,
                                 Integer idUser, String netID, Integer op_uid) {
        this(logger, action, idUser, netID, null, op_uid);
    }

    public UserLockUnLockCommand(stanford.netdb.utils.Logger logger, String action,
                                 Integer idUser, String netID, Timestamp tm, Integer op_uid) {
        super(logger);

        if( action.equals(LOCK_ACTION) ) db_call_type = ORA_FUN_CALL;

        values[ACTION_INDEX]  = action;
        if( idUser != null ) values[ID_INDEX]     = idUser;
        if( netID != null )  values[NET_ID_INDEX] = netID;
        values[OP_USER_INDEX] = op_uid;
        if( tm != null )     values[LOCKED_INDEX] = tm;
    }
}
