/************************************************************************
 *
 * Constants.java - all constants used throughout NetDB code.
 *                  Note, that users of netdb.jar should use only
 *                  constants defined in class NetDB.
 *
 * $Id: Constants.java,v 1.15 2007/04/21 05:57:15 jlidtke Exp $
 *
 *-----------------------------------------------------------------------
 * Copyright (c) 2002, Board of Trustees, Leland Stanford Jr. University
 ************************************************************************/
package stanford.netdb.utils;

public final class Constants extends Object {

    public static final String RELEASE_VERSION                  = "4.2.2";
    public static final String RELEASE_NAME                     = "Juicy FISH";
    public static final String RELEASE_ID                       = "04202007";
    public static final String BUILD_DATE                       = "4/20/2007";

    public static final int ID                                  = 1;
    public static final int NAME                                = 2;

    public static final int NODE                                = 3;
    public static final int USER                                = 4;
    public static final int NETWORK                             = 5;
    public static final int GROUP                               = 6;
    public static final int ATEAM                               = 7;
    public static final int DOMAIN                              = 8;
    public static final int ALL                                 = 9;
    public static final int OS                                  = 10;
    public static final int MAKE                                = 11;
    public static final int MX                                  = 12;
    public static final int IPADDRSPACE                         = 15;
    public static final int ADVANCED_NODE                       = 16;
    public static final int IPC_PROVIDER                        = 17;
    public static final int ROUTER                              = 18;
    public static final int SYSTEM_MANAGEMENT                   = 20;
    public static final int DEPARTMENT                          = 21;
    public static final int LOCATION                            = 22;
    public static final int MODEL                               = 24;
    public static final int INTERFACE                           = 25;
    public static final int DHCP_SERVICE                        = 26;
    public static final int NET_ONLY                            = 27;
    public static final int PERSON                              = 28;
    public static final int DHCP_OPTIONS                        = 29;
    public static final int LOG                                 = 30;
    public static final int MODEL_TYPE                          = 31;
    public static final int FULL_SEARCH_TYPE                    = 32;
    public static final int STATE                               = 33;
    public static final int NODE_TYPE                           = 34;

    public static final int IP                                  = 13;
    public static final int STRING                              = 14;

    // targets of quick search
    public static final String SEARCH_FOR_NAME                  = "name";
    public static final String SEARCH_FOR_IP_ADDR               = "ip";
    public static final String SEARCH_FOR_HW_ADDR               = "hw";
    public static final String SEARCH_FOR_NAME_NO_MX            = "name no mx";
    public static final String SEARCH_FOR_IP_ADDR_NEW           = "";
    public static final String SEARCH_FOR_NAME_NO_MX_NEW        = "";
    public static final String SEARCH_FOR_NET_NAME_NO_MX_ONLY   = "";

    // search constants for dirSearch
    public static final int NETID                               = 1;
    public static final int REGID                               = 2;
    public static final int LOOKUP                              = 3;

    // search constraints for quick search
    public static final int WI_NETWORK                          = 3;
    public static final int WI_NODE                             = 4;
    public static final int WI_USERS                            = 5;
    public static final int WI_DOMAIN                           = 6;
    public static final int WI_ADMINTEAM                        = 7;
    public static final int WI_OWNER                            = 8; // group

    // validation constants
    public static final int WIDE                                = 1;
    public static final int NARROW                              = 2;
    public static final int FULL                                = 3;

    public static final int MAX_CUSTOM_FIELDS                   = 4;

    public static final String NETDB_PROPERTIES_FILENAME        = "netdb.properties";
    public static final String NETDB_CSS_FILE                   = "netdb.css";
    public static final String ACL_FILENAME                     = "allow.access";

    // keys in netdb.properties
    public static final String DO_SYSLOG_KEY                    = "do.syslog";
    public static final String DBCONNECTION_USER_KEY            = "dbconnection.user";
    public static final String DBCONNECTION_PASSWORD_KEY        = "dbconnection.password";
    public static final String DBCONNECTION_SEARCH_USER_KEY     = "dbconnection.searchuser";
    public static final String DBCONNECTION_SEARCH_PASSWORD_KEY = "dbconnection.searchpassword";
    public static final String DBCONNECTION_URL_KEY             = "dbconnection.url";
    public static final String DBSCHEMA_KEY                     = "db.schema";
    public static final String TIMEOUT_KEY                      = "timeout";
    public static final String SYSLOG_HOST_KEY                  = "syslog.host";
    public static final String SYSLOG_PORT_KEY                  = "syslog.port";
    public static final String SYSLOG_FACILITY_KEY              = "syslog.facility";
    public static final String SYSLOG_PRIORITY_KEY              = "syslog.priority";
    public static final String SYSLOG_ID_STR_KEY                = "syslog.id.string";
    public static final String K5_SERVICE_KEY                   = "k5.service";
    public static final String UID_KEY                          = "set.uid";
    public static final String GID_KEY                          = "set.gid";
    public static final String NETDB_HTTP_PORT_KEY              = "http.port";
    public static final String IP_INTERFACE_KEY                 = "http.bind.ip.address";
    public static final String STANFORDWHO_URL_KEY              = "stanfordwho.url";
    public static final String HELPPAGESROOT_URL_KEY            = "helppagesroot.url";
    public static final String HELP_REQUEST_URL_KEY             = "help.request.url";
    public static final String ORG_STR_KEY                      = "org.str";
    public static final String DEPT_STR_KEY                     = "dept.str";
    public static final String RELEASE_VERSION_URL_KEY          = "release.version.url";
    public static final String RELEASE_NAME_URL_KEY             = "release.name.url";
    public static final String DIR_PROVIDER_CLASS_KEY           = "dir.provider.class";
    public static final String QUEUE_DEPTH_KEY                  = "max.concurrent.calls";
    public static final String AUTH_USER_KEY                    = "auth.userid.key";
    public static final String CHEAT_USER_KEY                   = "cheat.userid";

    // constants for loggin
    public static final int DEBUG                               = 1;
    public static final int WARN                                = 2;
    public static final int ERROR                               = 3;
    public static final int INFO                                = 4;

    // used by NetDB and NameReserveCommand
    public static final String DOMAIN_TYPE                      = "Domain";
    public static final String NODE_NAME_TYPE                   = "Node";
    public static final String ADDRESS_NAME_TYPE                = "Address";
    public static final String INTERFACE_NAME_TYPE              = "Interface";
    public static final String NETWORK_NAME_TYPE                = "Network";
    public static final String NAME_ALIAS_TYPE                  = "Alias";
    public static final String MX_TYPE                          = "MX";

    // date formats and our own formatter
    public static final String[] date_formats =
        new String[] { "MM/dd/yy", "MM-dd-yy", "dd-MMM-yy", "yyyy-MM-dd'T'HH:mm:ss" };

    public static final DateFormatter df = new DateFormatter(date_formats);
}
