/************************************************************************
 *
 * FieldMetaData.java -
 *
 * $Id: FieldMetaData.java,v 1.1.1.1 2006/06/30 23:38:10 priimak Exp $
 *
 *-----------------------------------------------------------------------
 * Copyright (c) 2003, Board of Trustees, Leland Stanford Jr. University
 ************************************************************************/
package stanford.netdb.utils;

public class FieldMetaData implements java.io.Serializable {

    // This class encapsulates the meta data
    // associcated with a field

    public static int FT_INT=0;
    public static int FT_STRING=1;
    public static int FT_DATE=3;

    private String fieldName;
    private int fieldType;
    private int fieldSize;

    public FieldMetaData(String n,int t, int s){
        fieldName = n;
        fieldType = t;
        fieldSize = s;
    }

    public void setType(int t){
        fieldType =t;
    }

    public int getType(){
        return fieldType;
    }

    public void setName(String n){
        fieldName = new String(n);
    }

    public String getName(){
        return new String(fieldName);
    }

    public void setSize(int s){
        fieldSize = s;
    }

    public int getSize(){
        return fieldSize;
    }

    public String toString() {
        return fieldName+":"+fieldSize;
    }
}
