/************************************************************************
 *
 * NetDBException.java -
 *
 * $Id: NetDBException.java,v 1.2 2006/07/28 19:46:20 priimak Exp $
 *
 *-----------------------------------------------------------------------
 * Copyright (c) 2002, 2002 Board of Trustees, Leland Stanford Jr. University
 ************************************************************************/
package stanford.netdb.utils;

import java.util.*;
import java.lang.*;
import java.io.*;

public class NetDBException extends Exception implements Serializable {

    private Vector messages = null;

    public NetDBException(String msg) {
        super(msg);
        messages = new Vector();
    }

    public NetDBException(String msg,  String[] messages) {
        super(msg);
        this.messages = new Vector();
        if( ( messages == null || messages.length == 0 ) && msg != null ) {
            this.messages.addElement(msg);
        } else
            for( int i = 0; i < messages.length; i++ )
                this.messages.addElement(messages[i]);
    }

    public NetDBException(String msg,  Vector messages) {
        super(msg);
        if( ( messages == null || messages.size() == 0 ) && msg != null ) {
            this.messages = new Vector();
            this.messages.addElement(msg);
        } else
            this.messages = messages;
    }

    public Vector getMessages() {
        return messages;
    }

    public NetDBException add(String msg) {
        messages.addElement(msg);
        return this;
    }

    public String toString() {
        String str = "NetDBException: ("+getMessage()+")";
        if( messages != null ) {
            for( int i = 0; i < messages.size(); i++ )
                str = " ["+messages.elementAt(i)+"]";
        }
        return str;
    }
}
