/************************************************************************
 *
 * FullSearchForm.java -
 *
 * $Id: FullSearchForm.java,v 1.14 2006/12/14 21:32:30 priimak Exp $
 *
 *-----------------------------------------------------------------------
 * Copyright (c) 2003, Board of Trustees, Leland Stanford Jr. University
 ************************************************************************/
package stanford.netdb.html;

import java.io.*;
import java.net.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;
import stanford.netdb.lib.*;
import stanford.netdb.utils.*;

public class FullSearchForm extends CommonPage {

    private static final String HW        = "hw";
    private static final String IP        = "ip";
    private static final String NUMERIC   = "num";
    private static final String TEXT      = "txt";
    private static final String TIMESTAMP = "tst";

    // column type for columns which should not be sorted
    private static final String NS        = "ns";

    public FullSearchForm() {}

    public void doGet(HttpServletRequest request, HttpServletResponse response)
        throws ServletException, IOException
    {
        Hashtable store = new Hashtable();
        store.put("no session store", "");

        HttpSession session = begin(request, response, store);
        if( session == null )
            return;

        Hashtable sd = nHash(session.getAttribute("full_search_data"));
        String output_format = ((String)Utils.n2s(sd.get("output_format"))).trim();
        if( output_format.length() == 0 )
            output_format = "formatted";

        String uid = ((String)Utils.n2s(Utils.nHash(session.getAttribute("user")).get("id"))).trim();

        try {
            // remove artifacts of the last search
            session.removeAttribute("sort column");
            session.removeAttribute("last direction sort");

            // build search form
            String search_type = (String)request.getParameter("searchtype");

            PrintWriter out = response.getWriter();

            out.println(getCommonHtmlBegin((search_type.equals("ATeam")?"Admin Team":search_type) + " Full Search",
                                           search_type.equals("Network")?("<script language=\"JavaScript\">\n"+
                                           "<!--\n"+
                                           " function ensure_proper_AddressSpace_selection(new_val) {\n"+
                                           "  if( new_val != '-1' && document.getElementById('displayOrder.ni.3.AddressSpace').value == '-1' )\n"+
                                           "   document.getElementById('displayOrder.ni.3.AddressSpace').value = '103';\n"+
                                           "  return true;\n"+
                                           " }\n\n"+
                                           " function ensure_proper_lo_hi_res_selection() {\n"+
                                           "  if( document.getElementById('displayOrder.ni.3.AddressSpace').value == '-1' ) {\n"+
                                           "   document.getElementById('displayOrder.nn.18.LowRes').value = '-1';\n"+
                                           "   document.getElementById('displayOrder.nn.19.HighRes').value = '-1';\n"+
                                           "  }\n"+
                                           "  return true;\n"+
                                           " }\n"+
                                           "//-->\n"+
                                           "</script>\n"):"")+
                        commonHeader(session, "/Dispatch?Action=redirect&to=/home&pre=remove_from_session&key=full_search_data"
                                     , SHOW_HOME_LINK, SHOW_PROFILE_LINK, SHOW_LOGOUT_LINK,
                                     "", (search_type.equals("ATeam")?"Admin Team":search_type) + " Full Search",
                                     search_type.equals("Log")?"hlplsearch.html":"hlpfsearch.html",
                                     decode((String)store.get("newFromPage")))+
                        msgPanels(session)+
                        "<DIV id=\"full_search_form\">"+
                        "\n<FORM METHOD='POST' ACTION='/FS'>\n"+
                        "<INPUT TYPE='Hidden' NAME='fromPage' VALUE='"+(String)store.get("newFromPage")+"'>"+
                        "<INPUT TYPE='Hidden' NAME='fromFromPage' VALUE='"+(String)store.get("fromPage")+"'>");

            out.println("<center CLASS=\"new_search_links\">Change to a different Search: "+
                        "<a href=\"/FullSearchForm?searchtype=Node\">Node</a>"+
                        "&nbsp;&nbsp;<a href=\"/FullSearchForm?searchtype=User\">User</a>"+
                        "&nbsp;&nbsp;<a href=\"/FullSearchForm?searchtype=Network\">Network</a>"+
                        "&nbsp;&nbsp;<a href=\"/FullSearchForm?searchtype=Group\">Group</a>"+
                        "&nbsp;&nbsp;<a href=\"/FullSearchForm?searchtype=ATeam\">Admin Team</a>"+
                        "&nbsp;&nbsp;<a href=\"/FullSearchForm?searchtype=Domain\">Domain</a></b>"+
                        "&nbsp;&nbsp;<a href=\"/FullSearchForm?searchtype=Log\">Log</a></b>"+
                        "</center><hr noshade size=1>"+
                        "<TABLE CLASS=\"search_buttons\" WIDTH='100%' CELLSPACING='1' CELLPADDING='0' BORDER='0'>\n"+
                        "<TR><TD ALIGN='CENTER' COLSPAN='3'><INPUT ID='Button_Search' TYPE='SUBMIT' NAME='ACTION' VALUE='Search'>"+
                        "&nbsp;&nbsp;&nbsp;<INPUT ID='Button_Reset' TYPE='SUBMIT' NAME='ACTION' VALUE='Reset'>"+
                        "&nbsp;&nbsp;&nbsp;<INPUT ID='Button_Cancel' TYPE='SUBMIT' NAME='ACTION' VALUE='Cancel'>"+
                        "</TD></TR>"+
                        "</TABLE>"+
                        "<BR>");

            if( search_type.equals("Domain") ) {
                if( sd.size() == 0 ) {
                    // default values
                    sd.put("rb.b.limited", "-1");
                    sd.put("rb.b.allow_name", "-1");
                }
                int total = 10;
                out.println(begin_sf("Domain", "FS_Domain")+
                            line(sd, "Domain Name", "txt.1.Domain Name", field(TEXT, sd, "lower(domain)", 29), 1, total, "Yes")+
                            line(sd, "Limited", "b.2.Limited Name",
                                 radio(sd, "b.limited", "1", "Yes")+"&nbsp;&nbsp;"+
                                 radio(sd, "b.limited", "0", "No")+"&nbsp;&nbsp;"+
                                 radio(sd, "b.limited", "-1", "Either"), 2, total, "-")+
                            line(sd, "Use as Name", "txt.4.Use as Name", field(TEXT, sd, "lower(useAsName)", 29)+
                                 "&nbsp;<a href=\"/List?what=Groups\" target=\"new\">Group list</a>", 3, total, "-")+
                            line(sd, "Assign Names", "txt.4.Assign Names", field(TEXT, sd, "lower(assignNamesIn)", 29)+
                                 "&nbsp;<a href=\"/List?what=Groups\" target=\"new\">Group list</a>", 4, total, "-")+
                            line(sd, "Group", "txt.4.Group", field(TEXT, sd, "lower(owner)", 29)+
                                 "&nbsp;<a href=\"/List?what=Groups\" target=\"new\">Group list</a>", 5, total, "Yes")+
                            thr()+
                            line(sd, "Comment", "txt.5.Comment", field(TEXT, sd, "lower(comments)", 29), 6, total, "-")+
                            thr()+
                            modBlock(sd, 7, total)+
                            thr()+
                            tln()+
                            actions(sd)+
                            end_sf());

            } else if( search_type.equals("ATeam") || search_type.equals("AdminTeam") ) {
                int total = 11;
                out.println(begin_sf("AdminTeam", "FS_AdminTeam")+
                            line(sd, "Team Name", "txt.1.Name", field(TEXT, sd, "lower(name)", 29), 1, total, "Yes")+
                            line(sd, "Department", "txt.2.Department", field(TEXT, sd, "lower(organization)", 29)+
                                 " <a href=\"/List?what=Departments\" target=\"new\">Departments list</a>",
                                 2, total, "-")+
                            line(sd, "Group", "txt.3.Group", field(TEXT, sd, "lower(owner)", 29)+
                                 " <a href=\"/List?what=Groups\" target=\"new\">Group list</a>",
                                 3, total, "Yes")+
                            line(sd, "Member", "txt.4.Member", "SUNet ID: "+field(TEXT, sd, "lower(member_netid)", 17)+
                                 " or Name: "+field(TEXT, sd, "lower(member_name)", 29), 4, total, "-")+

                            line(sd, "Email", "txt.5.Email", field(TEXT, sd, "lower(email)", 29), 5, total, "-")+
                            line(sd, "Phone", "txt.6.Phone", field(TEXT, sd, "lower(phone)", 29), 6, total, "-")+

                            thr()+
                            line(sd, "Comment", "txt.7.Comment", field(TEXT, sd, "lower(comments)", 29), 7, total, "-")+
                            thr()+
                            modBlock(sd, 8, total)+
                            thr()+
                            tln()+
                            actions(sd)+
                            end_sf());

            } else if( search_type.equals("Group") ) {
                int total = 6;
                out.println(begin_sf("Group", "FS_Owner")+
                            line(sd, "Group Name", "txt.1.Group Name", field(TEXT, sd, "lower(owner)", 29)+
                                 "<a href=\"/List?what=Groups\" target=\"new\">Group list</a>", 1, total, "Yes")+
                            thr()+
                            line(sd, "Comment", "txt.2.Comment", field(TEXT, sd, "lower(comments)", 29), 2, total, "-")+
                            thr()+
                            modBlock(sd, 3, total)+
                            thr()+
                            tln()+
                            actions(sd)+
                            end_sf());

            } else if( search_type.equals("Network") ) {
                if( sd.size() == 0 ) // default values
                    sd.put("fs.FS_NetworkIPaddresses.rb.b.active", "-1");

                int total = 17;
                out.println(begin_sf("Network", "FS_NetworkInfo")+
                            tln("<b>Network</b>")+
                            line(sd, "Name", "txt.1.Name:Network",
                                 field("fs.FS_NameNetwork."+TEXT, sd, "fullname_lc", 29), 1, total, "Yes")+
                            line(sd, "Location", "txt.2.Location",
                                 field("fs.FS_NetworkInfo."+TEXT, sd, "lower(location)", 29)+
                                 " <a href=\"/LocationsList\" target=\"new\">Locations list</a>", 2, total, "-")+
                            line(sd, "Address Spaces", "ni.3.AddressSpace",
                                 field("fs.FS_AddressSpace."+IP, sd, "address", 29), 3, total, "Yes",
                                 "onChange='ensure_proper_lo_hi_res_selection()'")+
                            line(sd, "DHCP Service", "txt.4.Service",
                                 field("fs.FS_NetworkInfo."+TEXT, sd, "lower(dhcp_service)", 29)+
                                 " <a href=\"/List?what=dhcp_services\" target=\"new\">Service list</a>",
                                 4, total, "-")+
                            line(sd, "DHCP Options", "txt.5.Network DHCPoption",
                                 field(TEXT, sd, "NetDHCPoptions", 29)+
                                 " <a href=\"/List?what=dhcp_options\" target=\"new\">Options list</a>",
                                 5, total, "-")+
                            line(sd, "Group", "txt.6.Network Group",
                                 field("fs.FS_NetworkInfo."+TEXT, sd, "lower(owner)", 29)+
                                 " <a href=\"/List?what=Groups\" target=\"new\">Group list</a>", 6, total, "-")+
                            line(sd, "Comment", "txt.7.Comment",
                                 field("fs.FS_NetworkInfo."+TEXT, sd, "lower(comments)", 29), 7, total, "-")+
                            thr()+
                            tln("<b>Address Space</b>")+
                            line(sd, "DHCP Options", "ns.8.AddressSpace DHCP Option",
                                 field(TEXT, sd, "ASDHCPoptions", 29)+
                                 " <a href=\"/List?what=dhcp_options\" target=\"new\">Options list</a>",
                                 8, total, "-")+
                            line(sd, "Group", "ns.9.AS Group",
                                 field("fs.FS_AddressSpaceOwner."+TEXT, sd, "lower(owner)", 29)+
                                 " <a href=\"/List?what=Groups\" target=\"new\">Group list</a>",
                                 9, total, "-")+
                            line(sd, "Comment", "ns.10.AScomment",
                                 field("fs.FS_AddressSpace."+TEXT, sd, "lower(comments)", 29), 10, total, "-")+
                            thr()+
                            tln("<b>Dynamic DHCP</b>")+
                            line(sd, "Address", "ni.11.Address",
                                 field("fs.FS_NetworkIPaddresses."+IP, sd, "IPaddress", 29), 11, total, "-")+
                            line(sd, "Name", "ns.12.Name:DHCP Address",
                                 field("fs.FS_NetworkIPaddresses."+TEXT, sd, "fullname_lc", 29), 12, total, "-")+
                            line(sd, "Address Status", "ns.13.Active Address",
                                 radio(sd, "fs.FS_NetworkIPaddresses.", "b.active", "1",  "Active")+"&nbsp;&nbsp;"+
                                 radio(sd, "fs.FS_NetworkIPaddresses.", "b.active", "0",  "Inactive")+"&nbsp;&nbsp;"+
                                 radio(sd, "fs.FS_NetworkIPaddresses.", "b.active", "-1", "Either"), 13, total, "-")+
                            thr()+
                            modBlock(sd, 14, total)+
                            thr()+
                            tln()+
                            line(sd, "Low Reserve", "nn.18.LowRes", "", 30, 0, "-",
                                 "onChange=\"ensure_proper_AddressSpace_selection(document.getElementById('displayOrder.nn.18.LowRes').value)\"")+
                            line(sd, "High Reserve", "nn.19.HighRes", "", 31, 0, "-",
                                 "onChange=\"ensure_proper_AddressSpace_selection(document.getElementById('displayOrder.nn.19.HighRes').value)\"")+
                            actions(sd)+
                            end_sf());

            } else if( search_type.equals("User") ) {
                if( sd.size() == 0 ) {
                    // default values
                    sd.put("rb.b.active", "-1");
                    sd.put("rb.b.official", "-1");
                    sd.put("rb.b.all_groups", "-1");
                    sd.put("rb.b.records", "-1");
                    sd.put("rb.b.all_records", "-1");
                }
                int total = 18;
                out.println(begin_sf("User", "FS_User")+
                            "<tr valign=\"baseline\">\n"+
                            "<td width=\"13%\">&nbsp;&nbsp;<b>User</b></td>\n"+
                            "<td nowrap=\"nowrap\">SUNet ID: <b>\n"+
                            "<input "+(sd.get("txt.netid error")!=null?"CLASS='error_form_font' ":"")+
                            "type=\"text\" name=\""+"txt.lower(netid)"+"\" size=\"17\" value=\""+
                            Utils.htmlize((String)Utils.n2s(sd.get("txt.lower(netid)")), false)+"\" /></b> or Name:\n"+
                            "<input "+(sd.get("txt.name error")!=null?"CLASS='error_form_font' ":"")+
                            "type=\"text\" size=\"29\" name=\""+"txt.lower(name)"+"\" value=\""+
                            Utils.htmlize((String)Utils.n2s(sd.get("txt.lower(name)")), false)+"\"/>\n"+
                            "</td>\n"+
                            "<td width=\"15%\" nowrap=\"nowrap\">\n"+
                            "<p align=\"left\">\n"+
                            "<input type=\"hidden\" name=\""+"displayOrder.txt.1.User Name"+"\" value=\"1\">\n"+
                            "<br>\n"+
                            "</p>\n"+
                            "</td>\n"+
                            "</tr>\n"+

                            line(sd, "Active Account", "b.2.Active",
                                 radio(sd, "b.active", "1", "Yes")+"&nbsp;&nbsp;"+
                                 radio(sd, "b.active", "0", "No")+"&nbsp;&nbsp;"+
                                 radio(sd, "b.active", "-1", "Either"), 2, total, "-")+
                            line(sd, "Last Login", "tst.3.Last Login", "On or After "+
                                 field(TIMESTAMP, sd, "last_login >= ", 10)+" Before "+
                                 field(TIMESTAMP, sd, "last_login <= ", 10), 3, total, "-")+
                            line(sd, "LNA", "ns.4.LNA",
                                 radio(sd, "b.official", "1", "Yes")+"&nbsp;&nbsp;"+
                                 radio(sd, "b.official", "0", "No")+"&nbsp;&nbsp;"+
                                 radio(sd, "b.official", "-1", "Either"), 4, total, "-")+
                            line(sd, "Department", "ns.5.Department", field(TEXT, sd, "lower(organization)", 29)+
                                 " <a href='/List?what=Departments' target='_blank'>Departments list</a>", 5, total, "Yes")+
                            line(sd, "<b>Networking Consultant<b>", "ns.6.Network Consultant",
                                 field(TEXT, sd, "cons_name", 29)+" <em>(Full Name)</em>", 6, total, "-")+
                            line(sd, "Group", "txt.7.Group", field(TEXT, sd, "lower(owner)", 29)+
                                 " <a href=\"/List?what=Groups\" target=\"new\">Group list</a>", 7, total, "-")+
                            "<tr>"+
                            "<td>&nbsp;&nbsp;<b>Access to all groups</b></td><td>"+
                            radio(sd, "b.all_groups", "1", "Yes")+"&nbsp;&nbsp;"+
                            radio(sd, "b.all_groups", "0", "No")+"&nbsp;&nbsp;"+
                            radio(sd, "b.all_groups", "-1", "Either")+
                            "</td></tr>"+
                            line(sd, "Record Type Access", "txt.8.Record Type",

                                 "<table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\n"+
                                 "<tr><td colspan=\"4\">"+
                                 radio(sd, "b.records", "-1", "don't search by record type access")+
                                 "</td></tr>\n"+

                                 "<tr>\n"+
                                 "<td width=\"20%\">"+
                                 radio(sd, "b.records", "2", "access to:")+
                                 "</td>\n"+

                                 "<td width=\"25%\">"+checkbox(sd, "i.Node",    "access_group = 'Node'",    "Nodes")+"</td>\n"+
                                 "<td width=\"25%\">"+checkbox(sd, "i.Network", "access_group = 'Network'", "Networks")+"</td>\n"+
                                 "<td width=\"30%\">"+checkbox(sd, "i.Domain",  "access_group = 'Domain'",  "Domains")+"</td>\n"+
                                 "</tr>\n"+

                                 "<tr>\n"+
                                 "<td width=\"20%\">&nbsp;</td>\n"+
                                 "<td width=\"25%\">"+checkbox(sd, "i.User",      "access_group = 'Users'",     "Users")+"</td>\n"+
                                 "<td width=\"25%\">"+checkbox(sd, "i.Group",     "access_group = 'Owner'",     "Groups")+"</td>\n"+
                                 "<td width=\"30%\">"+checkbox(sd, "i.AdminTeam", "access_group = 'AdminTeam'", "Admin Teams")+"</td>\n"+
                                 "</tr>\n"+

                                 "<tr>\n"+
                                 "<td width=\"20%\">&nbsp;</td>\n"+
                                 "<td width=\"25%\">"+checkbox(sd, "i.IPC",          "access_group = 'IPCProvider'",  "IPCs")+"</td>\n"+
                                 "<td colspan=\"2\">"+checkbox(sd, "i.AdvancedNode", "access_group = 'AdvancedNode'", "Advanced Nodes")+"</td>\n"+
                                 "</tr>\n"+

                                 "<tr>\n"+
                                 "<td width=\"20%\">&nbsp;</td>\n"+
                                 "<td width=\"25%\">"+checkbox(sd, "i.Router",           "access_group = 'Router'",           "Routers")+"</td>\n"+
                                 "<td colspan=\"2\">"+checkbox(sd, "i.SystemManagement", "access_group = 'SystemManagement'", "System Management")+"</td>\n"+
                                 "</tr>\n"+
                                 "</table>\n", 8, total, "-")+
                            "<tr>"+
                            "<td>&nbsp;&nbsp;<b>Access to all record types</b></td><td>"+
                            radio(sd, "b.all_records",  "1", "Yes")+"&nbsp;&nbsp;"+
                            radio(sd, "b.all_records",  "0", "No") +"&nbsp;&nbsp;"+
                            radio(sd, "b.all_records", "-1", "Either")+
                            "</td></tr>"+
                            thr()+
                            line(sd, "Comment", "txt.9.Comment", field(TEXT, sd, "lower(comments)", 29), 9, total, "-")+
                            line(sd, "Phone", "txt.10.Phone", field(TEXT, sd, "lower(phone)", 29), 10, total, "Yes")+
                            line(sd, "Email", "txt.11.Email", field(TEXT, sd, "lower(email)", 29), 11, total, "Yes")+
                            line(sd, "Default Domain", "txt.12.Default Domain", field(TEXT, sd, "lower(def_domain)", 29), 12, total, "-")+
                            line(sd, "Default Address Space", "ip.13.Default AddressSpace", field(TEXT, sd, "NetDB.IP.text(def_addr_space)", 29), 13, total, "-")+
                            line(sd, "Default Group", "txt.14.Default Group", field(TEXT, sd, "lower(def_group)", 29), 14, total, "-")+
                            thr()+
                            modBlock(sd, 15, total)+
                            thr()+
                            tln()+
                            actions(sd)+
                            end_sf());

            } else if( search_type.equals("Node") ) {
                if( sd.size() == 0 ) {
                    // default values
                    sd.put("cb.i.Name:Node",                   "Yes");
                    sd.put("cb.i.Name:Alias",                  "Yes");
                    sd.put("fs.FS_NodeIPaddress.rb.b.active",  "-1");
                    sd.put("fs.FS_NodeIPaddress.rb.b.PTRpref", "-1");
                    sd.put("fs.FS_NodeIPaddress.rb.b.dhcp",    "-1");
                    sd.put("fs.FS_NodeIPaddress.rb.b.roam",    "-1");
                }
                int total = 33;

                Hashtable all_node_types = nHash(getData(session, "node types"));
                String only_node_types = "";
                String exclude_node_types = "";

                for( Map.Entry ent : (java.util.List<Map.Entry>)Utils.sort(all_node_types.entrySet(), Utils.node_type_cmp) ) {
                    String type         = (String)ent.getKey();
                    String label        = Utils.htmlize(type).replaceAll(" ", "&nbsp;");
                    only_node_types    += checkbox(sd, "fs.FS_NodeType.", "i.only_"+type+"", "lower(type) = '"+type.toLowerCase()+"'", label)+" &nbsp;";
                    exclude_node_types += checkbox(sd, "fs.FS_NodeType.", "i.not_"+type+"", "lower(type) != '"+type.toLowerCase()+"'", label)+" &nbsp;";
                }

                out.println(begin_sf("Node", "FS_NodeInfo")+
                            "<tr>\n"+
                            "<td valign=\"top\" width=\"13%\"><b>\n"+
                            "&nbsp;&nbsp;Name</b> </td>\n"+
                            "<td valign=\"top\" nowrap=\"nowrap\">\n"+
                            "<p><input id='TextField_Name' "+(sd.get("fs.FS_NameNode.txt.fullname_lc error")!=null?"CLASS='error_form_font' ":"")+
                            "type=\"text\" size=\"29\" name=\""+"fs.FS_NameNode.txt.fullname_lc"+"\" value=\""+
                            Utils.htmlize((String)Utils.n2s(sd.get("fs.FS_NameNode.txt.fullname_lc")), false)+"\" /></p>\n"+
                            "</td>\n"+
                            "<td width=\"15%\" valign=\"top\" nowrap=\"nowrap\">&nbsp;"+
                            "<input type=\"hidden\" name=\"displayOrder.nodeName\" value=\"1\"></td>\n"+
                            "</tr>\n"+

                            line(sd, "Name Types", "ns.2.Name:Node",
                                 checkbox(sd, "i.Name:Node",      "node is not null",      "Node"),      2, total, "Yes")+
                            line(sd, "&nbsp;",     "ns.3.Name:Alias",
                                 checkbox(sd, "i.Name:Alias",     "aliasee is not null",   "Alias"),     3, total, "-")+
                            line(sd, "&nbsp;",     "ns.4.Name:Interface",
                                 checkbox(sd, "i.Name:Interface", "interface is not null", "Interface"), 4, total, "-")+
                            line(sd, "&nbsp;",     "ns.5.Name:IP",
                                 checkbox(sd, "i.Name:IP", "iptype = 'ip'", "IP Address"), 5, total, "-")+
                            line(sd, "&nbsp;",     "ns.6.Name:IPC",
                                 checkbox(sd, "i.Name:IPC", "iptype = 'ipc'", "IPC"), 6, total, "-")+
                            line(sd, "Receives Mail for", "ns.7.Receives Mail For", field("fs.FS_NodeMX."+TEXT, sd, "fullname_lc", 29)+
                                 " <em>(MX)</em>", 7, total, "-")+
                            line(sd, "Include Node Types", "txt.8.Node Type",
                                 "<table width=\"100%\">\n"+
                                 " <tr valign=\"top\">\n"+
                                 "  <td>\n"+only_node_types+
                                 "  </td>\n"+
                                 " </tr>\n"+
                                 "</table>\n", 8, total, "-")+
                            "<tr>\n"+
                            " <td width=\"13%\" valign=\"top\" nowrap>\n"+
                            "&nbsp;&nbsp;<b>Exclude Node Types</b>\n"+
                            " </td>\n"+
                            " <td valign=\"top\" nowrap=\"nowrap\">\n"+
                            "  <table width=\"100%\">\n"+
                            "   <tr valign=\"top\">\n"+
                            "    <td>\n"+exclude_node_types+
                            "    </td>\n"+
                            "   </tr>\n"+
                            "  </table>\n"+
                            " </td>\n"+
                            " <td valign=\"top\" width=\"15%\" nowrap=\"nowrap\">&nbsp;\n"+
                            " </td>\n"+
                            "</tr>\n"+
                            thr()+
                            line(sd, "State", "txt.9.State", field("fs.FS_Node."+TEXT, sd, "lower(state)", 29)+
                                 " <a href=\"/List?what=States\" target=\"new\">States list</a>", 9, total, "-")+
                            thr()+
                            line(sd, "IP Address", "ni.10.Address", field("fs.FS_NodeIPaddress."+IP, sd, "IPaddress", 29), 10, total, "Yes"));

                Iterator it_ptr = Utils.sortedKeys(CommonPage.ptr_pref, num_cmp);
                String ptr_pref_radio = "";
                while( it_ptr.hasNext() ) {
                    Hashtable ptr_pref = (Hashtable)CommonPage.ptr_pref.get(it_ptr.next());
                    ptr_pref_radio +=
                        radio(sd, "fs.FS_NodeIPaddress.", "b.PTRpref",
                              Utils.nStr(ptr_pref.get("value")),
                              Utils.htmlize(Utils.nStr(ptr_pref.get("short name"))))+"&nbsp;&nbsp;&nbsp;";
                }

                out.println(line(sd, "PTR Pref", "ns.11.PTR Pref", ptr_pref_radio+
                                 radio(sd, "fs.FS_NodeIPaddress.", "b.PTRpref", "-1", "Either"), 11, total, "-")+
                            line(sd, "IP Address Status", "ns.12.Active Address",
                                 radio(sd, "fs.FS_NodeIPaddress.", "b.active",  "1", "Active")+"&nbsp;&nbsp;&nbsp;"+
                                 radio(sd, "fs.FS_NodeIPaddress.", "b.active",  "0", "Inactive")+"&nbsp;&nbsp;&nbsp;"+
                                 radio(sd, "fs.FS_NodeIPaddress.", "b.active", "-1", "Either"), 12, total, "-")+
                            line(sd, "Hardware Address", "ns.13.Hardware Address",
                                 field("fs.FS_NodeIPaddress."+HW, sd, "lower(HW_address)", 29), 13, total, "Yes")+
                            line(sd, "DHCP", "ns.14.DHCP",
                                 radio(sd, "fs.FS_NodeIPaddress.", "b.dhcp",  "1", "Yes")+"&nbsp;&nbsp;&nbsp;"+
                                 radio(sd, "fs.FS_NodeIPaddress.", "b.dhcp",  "0", "No")+"&nbsp;&nbsp;&nbsp;"+
                                 radio(sd, "fs.FS_NodeIPaddress.", "b.dhcp", "-1", "Either"), 14, total, "-")+
                            line(sd, "&nbsp;", "ns.15.DHCP Option",
                                 "DHCP Options: "+field(TEXT, sd, "DHCPoptions", 29)+
                                 " <a href=\"/List?what=dhcp_options\" target=\"new\">Options list</a>", 15, total, "-")+
                            line(sd, "Roaming", "ns.16.Roaming",
                                 radio(sd, "fs.FS_NodeIPaddress.", "b.roam",  "1", "Yes")+"&nbsp;&nbsp;&nbsp;"+
                                 radio(sd, "fs.FS_NodeIPaddress.", "b.roam",  "0", "No")+"&nbsp;&nbsp;&nbsp;"+
                                 radio(sd, "fs.FS_NodeIPaddress.", "b.roam", "-1", "Either"), 16, total, "-")+
                            thr()+
                            line(sd, "Group", "txt.17.Group", field("fs.FS_Node."+TEXT, sd, "groupZ.lower(owner)", 29)+
                                 " <a href=\"/List?what=Groups\" target=\"new\">Group list</a><br>"+
                                 checkbox(sd, "i.f.InMyGroups", "groupZ.( select FS_Node_Owner.node id from FS_Users_Owner "+
                                          "join FS_Node_Owner on FS_Node_Owner.owner = FS_Users_Owner.owner "+
                                          "where FS_Users_Owner.userid = "+uid+" )", "Records in my groups"), 17, total, "-")+
                            line(sd, "Department", "txt.18.Department", field("fs.FS_Node."+TEXT, sd, "lower(department)", 29)+
                                 " <a href=\"/List?what=Departments\" target=\"new\">Departments list</a>", 18, total, "-")+
                            thr()+
                            line(sd, "Location", "txt.19.Location", field("fs.FS_Node."+TEXT, sd, "lower(location)", 29)+
                                 " <a href=\"/LocationsList\" target=\"new\">Locations list</a>", 19, total, "-")+
                            line(sd, "Site", "txt.20.Site", field("fs.FS_Node."+TEXT, sd, "lower(site)", 29), 20, total, "-")+
                            line(sd, "Code", "txt.21.Code", field("fs.FS_Node."+TEXT, sd, "lower(code)", 29), 21, total, "-")+
                            line(sd, "&nbsp;", "txt.22.Room", "Room: "+field("fs.FS_Node."+TEXT, sd, "lower(room)", 20), 22, total, "-")+
                            thr()+
                            line(sd, "Expiration Date", "tst.23.Expires On", "On or After "+field("fs.FS_Node."+TIMESTAMP, sd, "expiration >= ", 10)+
                                 " On or Before "+field("fs.FS_Node."+TIMESTAMP, sd, "expiration <= ", 10), 23, total, "-")+
                            line(sd, "Make &amp; Model", "txt.24.Make/Model", field("fs.FS_Node."+TEXT, sd, "lower(make)", 16)+
                                 " "+field("fs.FS_Node."+TEXT, sd, "lower(model)", 19)+
                                 " <a href='/List?what=make_and_model' target='_blank'>Make&amp;Model list</a>",
                                 24, total, "-")+
                            line(sd, "OS", "txt.25.Operating System", field("fs.FS_Node."+TEXT, sd, "lower(os)", 29)+
                                 " <a href='/List?what=OSes' target='_blank'>OS list</a>", 25, total, "-")+
                            line(sd, "Administrator", "txt.26.Node Administrator", "SUNet ID: "+
                                 field("fs.FS_Node_Admin."+TEXT, sd, "groupA.lower(admin_netid)", 17)+
                                 " or Name: "+field("fs.FS_Node_Admin."+TEXT, sd, "groupA.lower(admin_name)", 29)+"<br> or Admin Team: "+
                                 field("fs.FS_Node_Admin."+TEXT, sd, "groupA.lower(ateam)", 12), 26, total, "-")+
                            line(sd, "Node User", "txt.27.Node User", "SUNet ID: "+field("fs.FS_Node_User."+TEXT, sd, "groupU.lower(user_netid)", 17)+
                                 " or Name: "+field("fs.FS_Node_User."+TEXT, sd, "groupU.lower(user_name)", 29), 27, total, "-")+
                            line(sd, "Custom Fields", "txt.28.Node Tag", field(TEXT, sd, "customFields", 29)+
                                 "<br>Label=Value, e.g., \"vendor=sun\"", 28, total, "-")+
                            thr()+
                            line(sd, "Comment", "txt.29.Comment", field("fs.FS_Node."+TEXT, sd, "lower(comments)", 29), 29, total, "-")+
                            thr()+
                            modBlock(sd, 30, total)+
                            thr()+
                            tln()+
                            actions(sd)+
                            end_sf());

            } else if( search_type.equals("Log") ) {
                if( sd.size() == 0 ) {
                    // default values
                    sd.put("rb.b.recordtype", "'node'");

                    sd.put("cb.i.Add",    "Yes");
                    sd.put("cb.i.Delete", "Yes");
                    sd.put("cb.i.Update", "Yes");
                }

                int total = 8;
                out.println(begin_sf("Log", "FS_Log")+
                            line(sd, "Date of Action", "tst.1.Date of Action", "On or After "+
                                 field(TIMESTAMP, sd, "logdate >=", 10)+" Before "+
                                 field(TIMESTAMP, sd, "logdate <=", 10)+"(mm/dd/yy, m-d-yyyy)", 1, total, "Yes")+
                            line(sd, "Record Name", "txt.2.Record Name",
                                 field(TEXT, sd, "lower(record_name)", 29)+" (no aliases, interface names or address names)", 2, total, "Yes")+
                            line(sd, "Record ID", "num.3.Record ID",
                                 field(NUMERIC, sd, "record_id", 10), 3, total, "Yes")+
                            line(sd, "Record Type", "txt.4.Record Type",
                                 "<table width=\"100%\">\n"+
                                 " <tr valign=\"top\">\n"+
                                 "  <td>\n"+
                                 radio(sd, "b.recordtype", "'node'",      "Node")      +"&nbsp;&nbsp;"+
                                 radio(sd, "b.recordtype", "'user'",      "User")      +"&nbsp;&nbsp;"+
                                 radio(sd, "b.recordtype", "'network'",   "Network")   +"&nbsp;&nbsp;"+
                                 radio(sd, "b.recordtype", "'owner'",     "Group")     +"&nbsp;&nbsp;"+
                                 radio(sd, "b.recordtype", "'adminteam'", "Admin Team")+"&nbsp;&nbsp;"+
                                 radio(sd, "b.recordtype", "'domain'",    "Domain")+
                                 "  </td>\n"+
                                 " </tr>\n"+
                                 "</table>\n", 4, total, "Yes")+
                            line(sd, "IP Address", "ip.5.IP Address",
                                 field(IP, sd, "IPaddress", 29)+" (does not include IPC or dynamic DHCP addresses)", 5, total, "Yes")+
                            line(sd, "Node State", "txt.6.Node State",
                                 field(TEXT, sd, "lower(state)", 17)+
                                 " <a href=\"/List?what=States\" target=\"new\">States list</a>", 6, total, "Yes")+
                            line(sd, "User", "txt.7.User", "SUNet ID: "+
                                 field(TEXT, sd, "lower(netid)", 17)+" or Name: "+
                                 field(TEXT, sd, "lower(name)", 29), 7, total, "Yes")+
                            line(sd, "Action", "txt.8.Action",
                                 "<table width=\"100%\">\n"+
                                 " <tr valign=\"top\">\n"+
                                 "  <td>\n"+
                                 checkbox(sd, "i.Add",    "groupB.action = 'insert'", "Insert")+"&nbsp;&nbsp;"+
                                 checkbox(sd, "i.Delete", "groupB.action = 'delete'", "Delete")+"&nbsp;&nbsp;"+
                                 checkbox(sd, "i.Update", "groupB.action = 'update'", "Update")+
                                 "  </td>\n"+
                                 " </tr>\n"+
                                 "</table>\n", 8, total, "Yes")+
                            end_sf());
            } else
                out.println("<CENTER><H2><FONT COLOR=\"#AA0000\">Not implemented yet.</FONT></H2></CENTER>\n");

            out.println("<BR><TABLE CLASS=\"search_buttons\" WIDTH='100%' CELLSPACING='1' CELLPADDING='0' BORDER='0'>\n"+
                        "<TR><TD ALIGN='CENTER' COLSPAN='3'><INPUT TYPE='SUBMIT' NAME='ACTION' VALUE='Search'>"+
                        "&nbsp;&nbsp;&nbsp;<INPUT TYPE='SUBMIT' NAME='ACTION' VALUE='Reset'>"+
                        "&nbsp;&nbsp;&nbsp;<INPUT TYPE='SUBMIT' NAME='ACTION' VALUE='Cancel'>"+
                        "</TD></TR>"+
                        "</TABLE>"+
                        "</FORM>\n"+getCommonBottomLabel(search_type.equals("Log")?"hlplsearch.html":"hlpfsearch.html")+
                        "</DIV>"+
                        "</BODY>\n"+
                        "</HTML>\n");

            end(request, response);
        } catch (Exception ex) {
            // display error page
            handleException(response, ex);
            return;
        }

    } // end of doGet(...)

    private static String orderSelector(Hashtable sd, int index) {
        String name = ("displayOrder."+index).trim();
        String defValue = (""+(101+index)).trim();
        return "<select id=\""+name+"\" name=\""+name+"\" size=\"1\">\n"+
            "<option value=\"-1\""+(Utils.n2s(sd.get(name)).equals("-1")?" selected":"")+">-</option>\n"+
            "<option value=\""+defValue+"\""+
            (sd.get(name)==null||
             Utils.n2s(sd.get(name)).equals(defValue)?" selected":"")+">Yes</option>\n"+
            "<option value=\"1\""+(Utils.n2s(sd.get(name)).equals("1")?" selected":"")+">1</option>\n"+
            "<option value=\"2\""+(Utils.n2s(sd.get(name)).equals("2")?" selected":"")+">2</option>\n"+
            "<option value=\"3\""+(Utils.n2s(sd.get(name)).equals("3")?" selected":"")+">3</option>\n"+
            "</select>";
    }

    // selector for order of displaying of elements
    private static String orderSelector(String name, int place, int total_choices, String selected)
        throws java.io.UnsupportedEncodingException
    {
        return orderSelector(name, place, total_choices, selected, "");
    }

    // selector for order of displaying of elements
    private static String orderSelector(String name, int place, int total_choices, String selected, String onChange)
        throws java.io.UnsupportedEncodingException
    {
        String result = "<select id=\""+name+"\" name=\""+name+"\" size=\"1\" "+onChange+">\n"+
            "<option value=\"-1\""+(selected.equals("-")?" selected":"")+">-</option>\n"+
            "<option value=\""+place+"\""+(selected.equals("Yes")||selected.equals(""+place)?" selected":"")+
            ">Yes</option>\n";
        for( int i = 1; i <= total_choices; i++ )
            result += "<option value=\""+i+"\""+
                (selected.equals(i+"")?" selected":"")+">"+i+"</option>\n";
        return result+"</select>\n";
    }

    // text field
    private static String field(String type, Hashtable sd, String name, int length)
        throws java.io.UnsupportedEncodingException
    {
        return field(type, sd, name, length, null);
    }

    // text field with prefix title
    private static String field(String type, Hashtable sd, String name, int length, String title)
        throws java.io.UnsupportedEncodingException
    {
        String full_name = type+"."+name;
        return (title!=null?(title+" "):"")+"<input id=\""+full_name+"\" "+
            (sd.get(full_name+" error")!=null?"CLASS='error_form_font' ":"")+"type=\"text\" size=\""+length+"\"\n"+
            "name=\""+full_name+"\" value=\""+Utils.htmlize((String)Utils.n2s(sd.get(full_name)), false)+"\">\n";
    }

    // line in a table
    private static String thr() {
        return "<tr>\n"+
            "<td colspan=\"3\" height=\"4\">\n"+
            "<hr noshade=\"noshade\" size=\"1\" />\n"+
            "</td>\n"+
            "</tr>\n";
    }

    // empty row
    private static String tln() {
        return tln("&nbsp;");
    }

    // row with the text only
    private static String tln(String txt) {
        return "<tr><td colspan=\"2\">"+txt+"</td>"+
            "<td width=\"15%\">&nbsp;</td></tr>\n";
    }

    // one line in a full search form
    private static String line(Hashtable sd, String main_title, String name, String field,
                               int place, int total_choices, String defSelector )
        throws java.io.UnsupportedEncodingException
    {
        return line(sd, main_title, name, field, place, total_choices, defSelector, "");
    }

    // one line in a full search form
    private static String line(Hashtable sd, String main_title, String name, String field,
                               int place, int total_choices, String defSelector, String onChange)
        throws java.io.UnsupportedEncodingException
    {
        String selector = ((String)Utils.n2s(sd.get("displayOrder."+name))).trim();
        selector = selector.equals("")?defSelector:selector;

        return "<tr>\n"+
            "<td valign=\"top\" width=\"13%\" nowrap>&nbsp;&nbsp;<b>"+main_title+"</b></td>\n"+
            "<td valign=\"top\" nowrap=\"nowrap\">\n"+
            "<p>"+field+"</p>\n"+
            "</td>\n"+
            "<td width=\"15%\" valign=\"top\" nowrap=\"nowrap\">\n"+
            "<p align=\"left\">\n"+
            orderSelector("displayOrder."+name, 100+place, total_choices, selector, onChange)+
            "</p>\n"+
            "</td>\n"+
            "</tr>\n";
    }

    // Block of fields for created by and modified by common to all searches
    public static String modBlock(Hashtable sd, int start_pos, int total)
        throws java.io.UnsupportedEncodingException
    {
        return
            line(sd, "Modified by", "txt."+start_pos+".Modified By", "SUNet ID: "+field(TEXT, sd, "groupM.lower(mod_by_netid)", 17)+
                 " or Name: "+field(TEXT, sd, "groupM.lower(mod_by_name)", 29), start_pos, total, "-")+

            line(sd, "Modified Date", "tst."+(start_pos+1)+".Date Modified", "On or After "+field(TIMESTAMP, sd, "modified >= ", 10)+
                 " Before "+field(TIMESTAMP, sd, "modified <= ", 10), start_pos+1, total, "-")+

            line(sd, "Created by", "txt."+(start_pos+2)+".Created By", "SUNet ID: "+field(TEXT, sd, "groupC.lower(created_by_netid)", 17)+
                 " or Name: "+field(TEXT, sd, "groupC.lower(created_by_name)", 29), start_pos+2, total, "-")+

            line(sd, "Created Date", "tst."+(start_pos+3)+".Date Created", "On or After "+field(TIMESTAMP, sd, "created >= ", 10)+
                 " Before "+field(TIMESTAMP, sd, "created <= ", 10), start_pos+3, total, "-");

    }

    // section for displaying actions. Common to all full searches.
    private static String actions(Hashtable sd) {
        return "<tr>\n"+
            "<td valign=\"top\" colspan=\"2\" nowrap=\"nowrap\"><p>&nbsp;&nbsp;<b>Actions</b>(Links for Modify, Remove, Use as Template)</p></td>\n"+
            "<td width=\"15%\" valign=\"top\" nowrap=\"nowrap\">\n"+
            "<p align=\"left\">\n"+
            "<select id=\"displayOrder.Actions\" name=\"displayOrder.Actions\" size=\"1\">\n"+
            "<option value=\"No\""+(Utils.n2s(sd.get("displayOrder.Actions")).equals("Yes")?"":" selected")+">No</option>\n"+
            "<option value=\"Yes\""+(Utils.n2s(sd.get("displayOrder.Actions")).equals("Yes")?" selected":"")+">Yes</option>\n"+
            "</select></p>\n"+
            "</td>\n"+
            "</tr>\n";
    }

    // radio button without prefix
    private static String radio(Hashtable sd, String name, String value, String txt)
        throws java.io.UnsupportedEncodingException
    {
        return radio(sd, "", name, value, txt);
    }

    // radio button
    private static String radio(Hashtable sd, String prefix, String name, String value, String txt)
        throws java.io.UnsupportedEncodingException
    {
        String selected_value = (String)Utils.n2s(sd.get(prefix+"rb."+name));
        return "<input id=\""+prefix+"rb."+name+"/value="+value+"\" type=radio name=\""+
            prefix+"rb."+name+"\" value=\""+value+"\""+
            (selected_value.equals(value)?" checked":"")+"> "+txt;
    }

    private static String checkbox(Hashtable sd, String name, String txt)
        throws java.io.UnsupportedEncodingException
    {
        return checkbox(sd, name, "Yes", txt);
    }

    private static String checkbox(Hashtable sd, String name, String value, String txt)
        throws java.io.UnsupportedEncodingException
    {
        return checkbox(sd, "", name, value, txt);
    }

    // make html checkbox element
    private static String checkbox(Hashtable sd, String prefix, String name, String value, String txt)
        throws java.io.UnsupportedEncodingException
    {
        return "<input id=\"CheckBox_"+prefix+"cb."+name+"\" type=\"checkbox\" name=\""+
            prefix+"cb."+name+"\" value=\""+value+"\""+
            (sd.get(prefix+"cb."+name)!=null?"checked ":"")+"/> "+txt;
    }

    // beginning of the search form
    private static String begin_sf(String type, String table) throws java.io.UnsupportedEncodingException {
        return "<INPUT TYPE='Hidden' NAME='searchtype' VALUE='"+type+"'>"+
            "<INPUT TYPE='Hidden' NAME='fs.table' VALUE='"+table+"'>"+
            "<TABLE CLASS=\"search_entry_form\" WIDTH='100%' CELLSPACING='1' CELLPADDING='0' BORDER='0'>\n"+
            "<TR CLASS=\"search_form_headers\">"+
            "<TD VALIGN='MIDDLE' WIDTH='1%' NOWRAP>&nbsp;&nbsp;Search criteria:</TD>\n"+
            "<TD>&nbsp;</TD><TD WIDTH='1%' NOWRAP>Display&nbsp;&nbsp;</TD>\n"+
            "</TR>\n";
    }

    // end of search form
    private static String end_sf() {
        return tln()+"</table>\n";
    }
}
