/************************************************************************
 *
 * NetDBLogo.java - returns netdb logo gif.
 *
 * $Id: NetDBLogo.java,v 1.1.1.1 2006/06/30 23:38:11 priimak Exp $
 *
 *-----------------------------------------------------------------------
 * Copyright (c) 2002, Board of Trustees, Leland Stanford Jr. University
 ************************************************************************/
package stanford.netdb.html;

import java.io.*;
import java.net.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;
import stanford.netdb.lib.*;
import stanford.netdb.utils.*;

public class NetDBLogo extends HttpServlet
{
    public NetDBLogo() {}

    public void doGet(HttpServletRequest request, HttpServletResponse response)
        throws ServletException, IOException
    {
        response.setContentType("image/gif");
        try 
        {
            URL iconURL = ClassLoader.getSystemResource("NetDBlogo.gif");
            ServletOutputStream os = response.getOutputStream();
            InputStream is = iconURL.openStream();
            byte[] buffer = new byte[2048];
            int size = 0;
            for(;;) 
            {
                size = is.read(buffer);
                if (size < 0)
                    break;
                os.write(buffer, 0, size);
            }
        }
        catch (Exception ex) 
        {
            Utils.error(ex.getMessage());
        }
    }
}
