/************************************************************************
 *
 * NetDBMaster.java -
 *
 * $Id: NetDBMaster.java,v 1.1.1.1 2006/06/30 23:38:11 priimak Exp $
 *
 *-----------------------------------------------------------------------
 * Copyright (c) 2004, Board of Trustees, Leland Stanford Jr. University
 ************************************************************************/
package stanford.netdb.html;

import java.io.*;
import java.util.*;
import java.net.*;
import javax.servlet.*;
import javax.servlet.http.*;
import stanford.netdb.lib.*;
import stanford.netdb.utils.*;

public class NetDBMaster extends Object implements HttpSessionBindingListener {

    public static Hashtable statStore = new Hashtable();

    public void valueBound(HttpSessionBindingEvent e) {
        synchronized ( statStore ) {
            statStore.put(e.getSession().getId(), e.getSession());
        }
    }

    public void valueUnbound(HttpSessionBindingEvent e) {
        String jsid = e.getSession().getId();
        Utils.logger.info("http session ended ["+jsid+"]");
        synchronized ( statStore ) {
            statStore.remove(jsid);
        }
        System.gc();
        System.runFinalization();
    }
}
