/************************************************************************
 *
 * HtmlServer.java -
 *
 * $Id: HtmlServer.java,v 1.1.1.1 2006/06/30 23:38:11 priimak Exp $
 *
 *-----------------------------------------------------------------------
 * Copyright (c) 2001 Board of Trustees, Leland Stanford Jr. University
 ************************************************************************/
package stanford.netdb.whois;

import java.net.*;
import java.lang.*;

public class HtmlServer implements Runnable {
    private int port;
    private InetAddress bindAddr = null;

    public HtmlServer(int port) {
        this.port = port;
    }

    /**
     * Listens on http port. Once connection established passes
     * client socket to HttpResponder
     */
    public void run() {
        try {
            // open port
            ServerSocket server = new ServerSocket(port);

            WhoIsServer.info("Html Server Listening on port "+port);

            for(;;) {
                Socket client = server.accept();
                (new Thread(new HtmlResponder(client))).start();
            }
        } catch(Exception ex) {
            ex.printStackTrace();
            WhoIsServer.error("Exception in HtmlServer ["+ex+"]");
        }
    }
}
