use strict;

my $INLCUDE_FILE = ".inventory_include";  # only include files/dirs in this list

if ($#ARGV < 0) {
    die "usage: $0 base_directory\n"; }

build_list (shift (@ARGV));

sub build_list
{
    my ($cur_dir) = @_;

    if (-e "$cur_dir/$INLCUDE_FILE")
    {
        open (FILE, "$cur_dir/$INLCUDE_FILE") || die "Error opening '$cur_dir/$INLCUDE_FILE'\n";
        foreach my $line (<FILE>)
        {
            if ($line =~ /[^\s]/) {
                print $cur_dir."/".$line; }
        }
        close FILE;
    }

    foreach my $dir (readDir ($cur_dir, "dir")) {
        build_list ($dir); }
}

sub readDir
{
    my ($path, $type) = @_;

    if (! -e $path)
    {
        print STDERR "'$path' was not found.\n";
        return;
    }

    if (! -d $path) {
        return; }

    if (! opendir (DIR, $path))
    {
        print STDERR "Unable to open the path '$path'.\n";
        return;
    }

    if ($path !~ /\/$/) {
        $path .= "\/"; }

    my @list;
    foreach my $item (readdir (DIR))
    {
        my $dir = -d $path.$item;

        if (($type =~ /dir/i && $dir) || ($type =~ /file/i && ! $dir) || $type =~ /all/i)
        {
            if ($item !~ /^(\.|\.\.)$/) {
                push (@list, $path.$item); }
        }
    }
    closedir (DIR);

    return @list;
}
